
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   1. May 2006  18:51  *************

	processor  16F877
	radix  DEC

Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6

BANK0    UDATA
hlp_zeilen_zaehler RES   1
  GLOBAL hlp_zeilen_zaehler
hlp_spalten_zaehler RES   1
  GLOBAL hlp_spalten_zaehler
GLCD_WR     EQU   1
GLCD_RD     EQU   2
GLCD_CS1    EQU   3
GLCD_CS2    EQU   4
GLCD_A0     EQU   5
GLCD_DATA   EQU   0x08
_LcKA       RES   8
  GLOBAL _LcKA

  ; FILE GLCD_BASIS_ROUTINEN.C
			;/****************************************************************************************/
			;/* Basis-Unterprogramme zur Ansteuerung des Grafik-LCD (mit SED1520-Controller)         */
			;/* in C (CC5X)																			*/
			;/*																						*/
			;/* Entwickler: Buchgeher Stefan															*/
			;/* Entwicklungsbeginn der Software: 5. Maerz 2006										*/
			;/* Funktionsfaehig seit: 2. April 2006 					 							    */
			;/* Letzte Bearbeitung: 3. April 2006													*/
			;/****************************************************************************************/
			;
			;/****************** Projekt-Header einbinden ********************************************/
			;#include "PROJEKT.H"
			;
			;
			;/****************** externe Register ****************************************************/
			;unsigned char hlp_zeilen_zaehler;
			;unsigned char hlp_spalten_zaehler;
			;
			;
			;/****************** Basis-Unterprogramme zur Grafik-LCD-Ansteuerung *********************/
			;
			;/****************************************************************************************/
			;/* GLCD_INIT                                                                            */
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Grafik-LC-Display initialisieren						     						*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 keine																				*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/*                                                                                      */
			;/* Vorgehensweise:                                                                      */
			;/*	 Uebergibt nacheinander die Befehle zur Initialisierung an das Grafik-LC-Display. 	*/
			;/****************************************************************************************/
			;void GLCD_INIT(void)
			;{

PROG1   CODE
GLCD_INIT
	GLOBAL GLCD_INIT
			;  	GLCD_COMMAND(175);					// Display on
	MOVLW .175
	CALL  GLCD_COMMAND
			;	GLCD_COMMAND(164); 					// static drive off
	MOVLW .164
	CALL  GLCD_COMMAND
			;	GLCD_COMMAND(169);					// duty cyle: 1/32
	MOVLW .169
	CALL  GLCD_COMMAND
			;	GLCD_COMMAND(238);					// read modify write off
	MOVLW .238
	CALL  GLCD_COMMAND
			;	GLCD_COMMAND(192);					// line 0
	MOVLW .192
	CALL  GLCD_COMMAND
			;	GLCD_COMMAND(184);					// 1. Zeile
	MOVLW .184
	CALL  GLCD_COMMAND
			;	GLCD_COMMAND(0);					// 1. Spalte ("Column Address" auf 0 setzen)
	MOVLW .0
	GOTO  GLCD_COMMAND
			;}
			;
			;
			;/****************************************************************************************/
			;/* GLCD_COMMAND                                                                         */
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Umsetzung des Zeitdiagramms zum Senden eines Befehls an das Grafik-LC-Display    	*/
			;/*                                                                                      */
			;/*                       _____                       ________                           */
			;/*             A0        _____X_____________________X________                           */
			;/*                       _____                       ________                           */
			;/*             nCS1,nCS2 _____X_____________________X________                           */
			;/*                       ____________________________________                           */
			;/*             nRD					                                     				*/
			;/*                       ________                 ___________                           */
			;/*             nWR               \_______________/                                      */
			;/*                       ___________ ________________ _______                           */
			;/*             Data      ___________X________________X_______                           */
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 command																			*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/****************************************************************************************/
			;void GLCD_COMMAND(unsigned char command)
			;{
GLCD_COMMAND
	GLOBAL GLCD_COMMAND
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcKA+0
			;	GLCD_A0 = 0;
	BCF   0x06,GLCD_A0
			;	GLCD_CS1 = 0;
	BCF   0x06,GLCD_CS1
			;	GLCD_CS2 = 0;	 
	BCF   0x06,GLCD_CS2
			;
			;	GLCD_RD = 1;
	BSF   0x06,GLCD_RD
			;	GLCD_WR = 0;
	BCF   0x06,GLCD_WR
			;
			;	GLCD_DATA = command;
	MOVF  _LcKA+0,W
	MOVWF GLCD_DATA
			;
			;	GLCD_WR = 1;
	BSF   0x06,GLCD_WR
			;
			;	GLCD_CS1 = 1;
	BSF   0x06,GLCD_CS1
			;	GLCD_CS2 = 1;
	BSF   0x06,GLCD_CS2
			;}
	RETURN
			;
			;
			;/****************************************************************************************/
			;/* GLCD_DATA1  									     									*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Umsetzung des Zeitdiagramms zum Senden von Daten an die erste Haelfte des         	*/
			;/*	 Grafik-LC-Display                                                                	*/
			;/*                                                                                      */
			;/*                       _____ _____________________ ________                           */
			;/*             A0, nCS1  _____X                     X________                          	*/
			;/*                       _____                       ________                           */
			;/*             nCS2      _____X_____________________X________                           */
			;/*                       ____________________________________                           */
			;/*             nRD					                                     				*/
			;/*                       ________                 ___________                           */
			;/*             nWR               \_______________/                                      */
			;/*                       ___________ ________________ _______                           */
			;/*             Data      ___________X________________X_______                           */
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 data																				*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/****************************************************************************************/
			;void GLCD_DATA1(unsigned char data)
			;{
GLCD_DATA1
	GLOBAL GLCD_DATA1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcKA+1
			;	GLCD_A0 = 1;
	BSF   0x06,GLCD_A0
			;	GLCD_CS1 = 1;
	BSF   0x06,GLCD_CS1
			;	GLCD_CS2 = 0;	 
	BCF   0x06,GLCD_CS2
			;
			;	GLCD_RD = 1;
	BSF   0x06,GLCD_RD
			;	GLCD_WR = 0;
	BCF   0x06,GLCD_WR
			;
			;	GLCD_DATA = data;
	MOVF  _LcKA+1,W
	MOVWF GLCD_DATA
			;
			;	GLCD_WR = 1;
	BSF   0x06,GLCD_WR
			;
			;	GLCD_CS1 = 1;
	BSF   0x06,GLCD_CS1
			;	GLCD_CS2 = 1;
	BSF   0x06,GLCD_CS2
			;}
	RETURN
			;
			;
			;/****************************************************************************************/
			;/* GLCD_DATA2  									     									*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Umsetzung des Zeitdiagramms zum Senden von Daten an die zweite Haelfte des         */
			;/*   Grafik-LC-Display                                                                	*/
			;/*                                                                                      */
			;/*                       _____ _____________________ ________                           */
			;/*             A0, nCS2  _____X                     X________                          	*/
			;/*                       _____                       ________                           */
			;/*             nCS1      _____X_____________________X________                           */
			;/*                       ____________________________________                           */
			;/*             nRD					                                     				*/
			;/*                       ________                 ___________                           */
			;/*             nWR               \_______________/                                      */
			;/*                       ___________ ________________ _______                           */
			;/*             Data      ___________X________________X_______                           */
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 data																				*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/****************************************************************************************/
			;void GLCD_DATA2(unsigned char data)
			;{
GLCD_DATA2
	GLOBAL GLCD_DATA2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcKA+2
			;	GLCD_A0 = 1;
	BSF   0x06,GLCD_A0
			;	GLCD_CS1 = 0;
	BCF   0x06,GLCD_CS1
			;	GLCD_CS2 = 1;	 
	BSF   0x06,GLCD_CS2
			;
			;	GLCD_RD = 1;
	BSF   0x06,GLCD_RD
			;	GLCD_WR = 0;
	BCF   0x06,GLCD_WR
			;
			;	GLCD_DATA = data;
	MOVF  _LcKA+2,W
	MOVWF GLCD_DATA
			;
			;	GLCD_WR = 1;
	BSF   0x06,GLCD_WR
			;
			;	GLCD_CS1 = 1;
	BSF   0x06,GLCD_CS1
			;	GLCD_CS2 = 1;
	BSF   0x06,GLCD_CS2
			;}  
	RETURN
			; 
			;
			;/****************************************************************************************/
			;/* GLCD_DATA_ZEICHEN  									     							*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Je nach aktueller Position des Cursors den Wert (data) an die erste oder zweite    */
			;/*   Displayhaelfte uebergeben.                                                         */
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 data																				*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/*																						*/
			;/* Vorgehensweise:																		*/
			;/*   + Befindet sich der Cursor an der 62. Spalte (hlp_spalten_zaehler = 61), die so-   */
			;/*     genannte "Column Address" auf 0 setzen (gemaess Datenblatt). Dies bewirkt, dass 	*/
			;/*	   der Display-interne Speicherzaehler wieder bei 0 beginnt. (siehe Datenblatt)		*/
			;/*   + Befindet sich der Cursor an eine Spalte groesser als 61 (also zweite Display- 	*/
			;/*	   haelfte) den Uebergabewert (data) mit dem Unterprogramm GLCD_DATA2 an die 		*/
			;/*	   zweite Displayhaelfte uebergeben. Andernfalls den Uebergabewert (data) mit dem 	*/
			;/*	   Unterprogramm GLCD_DATA1 an die erste Displayhaelfte uebergeben.					*/
			;/*																						*/
			;/* Anmerkung:                                                                  			*/
			;/*	 Das (externe) Hilfsregister hlp_spalten_zaehler gibt an, an welcher Spalte sich    */
			;/*   der Cursor befindet.																*/	
			;/****************************************************************************************/
			;void GLCD_DATA_ZEICHEN(unsigned char data)
			;{
GLCD_DATA_ZEICHEN
	GLOBAL GLCD_DATA_ZEICHEN
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcKA+3
			;	if (hlp_spalten_zaehler == 61)		// Wenn Cursorspalte = 61 ...
	MOVF  hlp_spalten_zaehler,W
	XORLW .61
	BTFSS 0x03,Zero_
	GOTO  m001
			;	{
			;		GLCD_COMMAND(0);				//   ... "Column Address" auf 0 setzen
	MOVLW .0
	CALL  GLCD_COMMAND
			;	}
			;	if (hlp_spalten_zaehler > 60)		// Cursorspalte > 60
m001	MOVLW .61
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF hlp_spalten_zaehler,W
	BTFSS 0x03,Carry
	GOTO  m002
			;	{
			;  		GLCD_DATA2(data);				// ja: Uebergabewert (data) mit dem an 
	MOVF  _LcKA+3,W
	CALL  GLCD_DATA2
			;	}									//   die zweite Displayhaelfte uebergeben.
			;	else
	GOTO  m003
			;	{
			;  		GLCD_DATA1(data);			 	// nein: Uebergabewert (data) mit dem an
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcKA+3,W
	CALL  GLCD_DATA1
			;	}									//   die erste Displayhaelfte uebergeben.
			;	hlp_spalten_zaehler++;
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  hlp_spalten_zaehler,1
			;}
	RETURN
			;
			;
			;/****************************************************************************************/
			;/* GLCD_CLEAR										     								*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Loeschen des Grafik-LC-Displays                                                  	*/
			;/*                                                                                      */
			;/* Uebergabeparameter:                                                                  */
			;/*   keine																				*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*   keiner																				*/
			;/*																						*/
			;/* Vorgehensweise:                                                                      */
			;/*   Beginnend bei der ersten Zeile und ersten Spalte mit Hilfe zweier geschachtelten	*/
			;/*   Schleifen Nullen zum Grafik-LC-Display (in beide Display-Haelften) schreiben. Dies */
			;/*	 bewirkt, dass am Display nichts angezeigt wird bzw. das Display wird somit ge-		*/
			;/*	 loescht.																			*/
			;/****************************************************************************************/
			;void GLCD_CLEAR(void)
			;{
GLCD_CLEAR
	GLOBAL GLCD_CLEAR
			;	unsigned char Zeile, Spalte;
			;
			;
			;	for(Zeile = 0; Zeile < 4; Zeile++)
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  _LcKA+4
m004	MOVLW .4
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF _LcKA+4,W
	BTFSC 0x03,Carry
	GOTO  m007
			;	{
			;		GLCD_COMMAND(184 + Zeile);				// Befehl: naechste Zeile
	MOVLW .184
	ADDWF _LcKA+4,W
	CALL  GLCD_COMMAND
			;		
			;		GLCD_COMMAND(0);						// Befehl: 1.Spalte der Zeile ("Column  
	MOVLW .0
	CALL  GLCD_COMMAND
			;												//  Address" auf 0 setzen)
			;		for(Spalte = 0; Spalte < 61; Spalte++)
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  _LcKA+5
m005	MOVLW .61
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF _LcKA+5,W
	BTFSC 0x03,Carry
	GOTO  m006
			;		{
			;			GLCD_DATA1(0);
	MOVLW .0
	CALL  GLCD_DATA1
			;			GLCD_DATA2(0);
	MOVLW .0
	CALL  GLCD_DATA2
			;		}	
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  _LcKA+5,1
	GOTO  m005
			;	}
m006	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  _LcKA+4,1
	GOTO  m004
			;}
m007	RETURN
			;
			;
			;/****************************************************************************************/
			;/* GLCD_SETCURSOR_ZEILE										     						*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Den Cursor an die uebergebene Zeile setzen									      	*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*   zeile:  0 - 3																		*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*   keiner																				*/
			;/*                                                                                      */
			;/* Vorgehensweise:                                                                      */
			;/*	 Uebergabeparameter fuer die Zeile im globalen Register hlp_zeilen_zaehler sichern  */
			;/*   und an das Grafik-LC-Display uebergeben.										    */
			;/****************************************************************************************/
			;void GLCD_SETCURSOR_ZEILE(unsigned char zeile)
			;{
GLCD_SETCURSOR_ZEILE
	GLOBAL GLCD_SETCURSOR_ZEILE
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcKA+6
			;	hlp_zeilen_zaehler = zeile;
	MOVF  _LcKA+6,W
	MOVWF hlp_zeilen_zaehler
			;	GLCD_COMMAND(184 + zeile);
	MOVLW .184
	ADDWF _LcKA+6,W
	GOTO  GLCD_COMMAND
			;}
			;
			;
			;/****************************************************************************************/
			;/* GLCD_SETCURSOR_SPALTE										     					*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Den Cursor an die uebergebene Spalte setzen                 						*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*   spalte: 0 - 121																	*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*   keiner																				*/
			;/*                                                                                      */
			;/* Vorgehensweise:                                                                      */
			;/*   Uebergabeparameter fr die Spalte im globalen Register hlp_spalten_zaehler sichern */
			;/*	 und an das Grafik-LC-Display uebergeben. Dabei ist zu beachten, dass das Grafik-LC-*/
			;/*   Display in zwei Bereiche aufgeteilt ist, wobei beide Bereiche mit 0 beginnen.      */
			;/*   Spalten groesser als 61 befinden sich im zweiten Bereich. Da diese wieder ab 0     */
			;/*   beginnen muessen bei den Spalten die groesser als 61 sind 61 abgezogen werden.		*/
			;/****************************************************************************************/
			;void GLCD_SETCURSOR_SPALTE(unsigned char spalte)
			;{
GLCD_SETCURSOR_SPALTE
	GLOBAL GLCD_SETCURSOR_SPALTE
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcKA+7
			;	hlp_spalten_zaehler = spalte;
	MOVF  _LcKA+7,W
	MOVWF hlp_spalten_zaehler
			;	if (spalte < 61)
	MOVLW .61
	SUBWF _LcKA+7,W
	BTFSC 0x03,Carry
	GOTO  m008
			;	{
			;  		GLCD_COMMAND(spalte);
	MOVF  _LcKA+7,W
	CALL  GLCD_COMMAND
			;	}	
			;	else
	GOTO  m009
			;	{
			;  		GLCD_COMMAND(spalte - 61);
m008	MOVLW .61
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF _LcKA+7,W
	GOTO  GLCD_COMMAND
			;	}	
			;}
m009	RETURN

	END


; *** KEY INFO ***

; 0x0001 P0   14 word(s)  0 % : GLCD_INIT
; 0x000F P0   14 word(s)  0 % : GLCD_COMMAND
; 0x001D P0   14 word(s)  0 % : GLCD_DATA1
; 0x002B P0   14 word(s)  0 % : GLCD_DATA2
; 0x0039 P0   26 word(s)  1 % : GLCD_DATA_ZEICHEN
; 0x0053 P0   36 word(s)  1 % : GLCD_CLEAR
; 0x0077 P0    8 word(s)  0 % : GLCD_SETCURSOR_ZEILE
; 0x007F P0   18 word(s)  0 % : GLCD_SETCURSOR_SPALTE

; RAM usage: 34 bytes (8 local), 334 bytes free
; Maximum call level: 1
;  Codepage 0 has  145 word(s) :   7 %
;  Codepage 1 has    0 word(s) :   0 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has    0 word(s) :   0 %
; Total of 145 code words (1 %)
