
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   1. May 2006  18:51  *************

	processor  16F877
	radix  DEC

	EXTERN GLCD_DATA_ZEICHEN
	EXTERN GLCD_SETCURSOR_ZEILE
	EXTERN GLCD_SETCURSOR_SPALTE
PCL         EQU   0x02
PCLATH      EQU   0x0A
Carry       EQU   0
RP0         EQU   5
RP1         EQU   6
  EXTERN hlp_zeilen_zaehler
  EXTERN hlp_spalten_zaehler

BANK0    UDATA
_LcAA       RES   4
  GLOBAL _LcAA
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
RD          EQU   0
EEPGD       EQU   7

  ; FILE GLCD_FONT10X22.c
			;/****************************************************************************************/
			;/* Unterprogramme zur Ansteuerung des Grafik-LCD (mit SED1520-Controller) in C (CC5X)	*/
			;/* (Font 10x22)																			*/
			;/*																						*/
			;/* Entwickler: Buchgeher Stefan															*/
			;/* Entwicklungsbeginn der Software: 5. Maerz 2006										*/
			;/* Funktionsfaehig seit: 2. April 2006 					 							    */
			;/* Letzte Bearbeitung: 12. April 2006													*/
			;/****************************************************************************************/
			;
			;/****************** Projekt-Header einbinden ********************************************/
			;#include "PROJEKT.H"
			; 
			;
			;/****************** Unterprogramme zur Grafik-LCD-Ansteuerung ***************************/
			;
			;/****************************************************************************************/
			;/* GLCD_ZEICHEN_10x22  									     							*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Ein Zeichen (Charakter im Format 10x22) am Grafik-LC-Display ausgeben		    	*/
			;/*                                                                                      */
			;/* Uebergabeparameter:                                                                  */
			;/* 	 zeichen			                                                                */
			;/*                                                                                      */
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/*                                                                                      */
			;/* Vorgehensweise:                                                                      */
			;/*   + die externen Hilfsregister (hlp_zeilen_zaehler und hlp_spalten_zaehler) sichern, */
			;/*     da sie hier benoetigt, aber gleichzeitig hier auch veraendert werden)			*/
			;/*	 + Nacheinander die Spalten fuer die erste Zeile des auszugebenden Zeichens an das  */
			;/*     Grafik-LC-Display mit dem Unterprogramm GLCD_DATA_ZEICHEN uebergeben. Die Daten  */
			;/*	   fuer die Spalten sind in Tabellen abgelegt, wobei fuer jede Spalte des Zeichens  */
			;/*	   eine eigene Tabelle vorhanden ist. Diese Tabellen muessen an anderer Stelle 		*/
			;/*	   hinzugefuegt werden! Die letzten beiden Spalten mssen eine 0 enthalten, also	*/
			;/*	   eine "Leerspalte"																*/
			;/*	 + Den Cursor an die naechste Zeile (tmp_zeile + 1) und die erste Spalte des 		*/
			;/*     Zeichens (tmp_spalte) setzen.													*/
			;/*   + In gleicher weise wie vorher die Spalten fuer die zweite Zeile des auszugebenden */
			;/*	   Zeichens an das Grafik-LC-Display mit dem Unterprogramm GLCD_DATA_ZEICHEN 		*/
			;/*	   uerbergeben.																		*/
			;/*	 + Den Cursor an die naechste Zeile (tmp_zeile + 2) und die erste Spalte des 		*/
			;/*     Zeichens (tmp_spalte) setzen.													*/
			;/*   + In gleicher weise wie vorher die Spalten fuer die dritte Zeile des auszugebenden */
			;/*	   Zeichens an das Grafik-LC-Display mit dem Unterprogramm GLCD_DATA_ZEICHEN 		*/
			;/*	   uerbergeben.																		*/
			;/*   + Den Cursor an die erste Zeile des Zeichens (tmp_zeile) und an die Spalte vom 	*/
			;/*	   Ende des Zeichen	(tmp_spalte + 12) setzen										*/
			;/****************************************************************************************/
			;void GLCD_ZEICHEN_10x22(unsigned char zeichen)
			;{

PROG1   CODE
_const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcAA+3
	MOVLW .120
	SUBWF _LcAA+3,W
	BTFSS 0x03,Carry
	GOTO  m001
	RETLW .0
m001	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVLW HIGH(Cgto1)
	MOVWF PCLATH
	MOVF  _LcAA+3,W
	ADDLW LOW(Cgto1)
	BTFSC 0x03,Carry
	INCF  PCLATH,1
	MOVWF PCL
Cgto1
	RETLW .248
	RETLW .112
	RETLW .120
	RETLW .120
	RETLW .0
	RETLW .254
	RETLW .248
	RETLW .62
	RETLW .248
	RETLW .248
	RETLW .2
	RETLW .68
	RETLW .66
	RETLW .66
	RETLW .128
	RETLW .2
	RETLW .2
	RETLW .34
	RETLW .2
	RETLW .2
	RETLW .226
	RETLW .194
	RETLW .98
	RETLW .98
	RETLW .96
	RETLW .242
	RETLW .226
	RETLW .50
	RETLW .226
	RETLW .226
	RETLW .18
	RETLW .2
	RETLW .18
	RETLW .18
	RETLW .134
	RETLW .18
	RETLW .18
	RETLW .18
	RETLW .18
	RETLW .18
	RETLW .226
	RETLW .254
	RETLW .226
	RETLW .226
	RETLW .226
	RETLW .18
	RETLW .98
	RETLW .242
	RETLW .226
	RETLW .226
	RETLW .248
	RETLW .0
	RETLW .248
	RETLW .248
	RETLW .254
	RETLW .30
	RETLW .120
	RETLW .254
	RETLW .248
	RETLW .248
	RETLW .255
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .248
	RETLW .31
	RETLW .255
	RETLW .0
	RETLW .231
	RETLW .31
	RETLW .0
	RETLW .0
	RETLW .128
	RETLW .0
	RETLW .1
	RETLW .16
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .64
	RETLW .255
	RETLW .255
	RETLW .96
	RETLW .60
	RETLW .56
	RETLW .19
	RETLW .243
	RETLW .192
	RETLW .195
	RETLW .71
	RETLW .0
	RETLW .0
	RETLW .134
	RETLW .36
	RETLW .33
	RETLW .18
	RETLW .18
	RETLW .7
	RETLW .36
	RETLW .72
	RETLW .255
	RETLW .255
	RETLW .97
	RETLW .195
	RETLW .63
	RETLW .226
	RETLW .226
	RETLW .192
	RETLW .195
	RETLW .207
	RETLW .255
	RETLW .0
	RETLW .1
	RETLW .231
	RETLW .255
	RETLW .248
	RETLW .248
	RETLW .0
	RETLW .231
	RETLW .255
_const2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcAA+3
	MOVLW HIGH(cwdata1)
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   _LcAA+3,W
	ANDLW .127
	ADDLW LOW(cwdata1)
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSS 0x03,Carry
	GOTO  m002
	INCF  EEADRH,1
m002	BSF   0x03,RP0
	BSF   0x03,RP1
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC _LcAA+3,0
	GOTO  m003
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW .127
	RETURN
m003	BCF   0x03,RP0
	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	RETURN
cwdata1
	DW    0x2404
	DW    0x2244
	DW    0x100
	DW    0x1104
	DW    0x204
	DW    0x112
	DW    0x912
	DW    0x918
	DW    0x912
	DW    0x912
	DW    0x2
	DW    0x102
	DW    0x902
	DW    0x142
	DW    0x102
	DW    0x4
	DW    0x204
	DW    0x902
	DW    0x144
	DW    0x204
	DW    0x0
	DW    0x0
	DW    0x806
	DW    0x0
	DW    0x1018
	DW    0x0
	DW    0x1218
	DW    0x926
	DW    0x1C12
	DW    0x2424
	DW    0x0
	DW    0x18
	DW    0x100
	DW    0x1C02
	DW    0x0
	DW    0x0
	DW    0xC06
	DW    0x200
	DW    0x384
	DW    0x18
	DW    0x3C1F
	DW    0xF78
	DW    0x3C01
	DW    0x1F
	DW    0xF1F
	DW    0x2420
	DW    0x1146
	DW    0x2401
	DW    0x3820
	DW    0x1120
	DW    0x2440
	DW    0x2141
	DW    0x2401
	DW    0x2740
	DW    0x2140
	DW    0x27C7
	DW    0x2340
	DW    0x2401
	DW    0x20C7
	DW    0x2347
	DW    0x2048
	DW    0x244E
	DW    0x2401
	DW    0x3848
	DW    0x2448
	DW    0x2048
	DW    0x2449
	DW    0x2401
	DW    0x748
	DW    0x2448
	DW    0x27C7
	DW    0x23C8
	DW    0x23FF
	DW    0xC7
	DW    0x23C7
	DW    0x2440
	DW    0x2048
	DW    0x2040
	DW    0x40
	DW    0x2040
	DW    0x2420
	DW    0x1048
	DW    0x1040
	DW    0x20
	DW    0x1020
	DW    0x3C1F
	DW    0xFF8
	DW    0xFFF
	DW    0x1F
	DW    0xF9F
GLCD_ZEICHEN_10x22
	GLOBAL GLCD_ZEICHEN_10x22
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcAA+0
			;	char tmp_zeile = hlp_zeilen_zaehler;
	MOVF  hlp_zeilen_zaehler,W
	MOVWF _LcAA+1
			;	char tmp_spalte = hlp_spalten_zaehler;
	MOVF  hlp_spalten_zaehler,W
	MOVWF _LcAA+2
			;  
			;	
			;	// 1.Zeile
			;	// 1. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp1[zeichen]);
	MOVF  _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 2. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp2[zeichen]);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 3. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp3[zeichen]);
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 4. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp4[zeichen]);
	MOVLW .20
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 5. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp5[zeichen]);
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 6. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp6[zeichen]);
	MOVLW .30
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 7. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp7[zeichen]);
	MOVLW .40
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 8. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp8[zeichen]);
	MOVLW .20
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 9. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp9[zeichen]);
	MOVLW .30
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 10. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z1sp10[zeichen]);
	MOVLW .50
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 11. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	CALL  GLCD_DATA_ZEICHEN
			;	// 12. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	CALL  GLCD_DATA_ZEICHEN
			;
			;	
			;	// 2. Zeile und 1.Spalte des Zeichen
			;	GLCD_SETCURSOR_ZEILE(tmp_zeile + 1);
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  _LcAA+1,W
	CALL  GLCD_SETCURSOR_ZEILE
			;	GLCD_SETCURSOR_SPALTE(tmp_spalte);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcAA+2,W
	CALL  GLCD_SETCURSOR_SPALTE
			;
			;	// 1. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp1[zeichen]);
	MOVLW .60
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 2. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp2[zeichen]);
	MOVLW .40
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 3. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp3[zeichen]);
	MOVLW .70
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 4. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp4[zeichen]);
	MOVLW .80
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 5. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp5[zeichen]);
	MOVLW .50
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 6. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp6[zeichen]);
	MOVLW .90
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 7. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp7[zeichen]);
	MOVLW .100
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 8. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp8[zeichen]);
	MOVLW .60
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 9. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp9[zeichen]);
	MOVLW .70
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 10. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z2sp10[zeichen]);
	MOVLW .110
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 11. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	CALL  GLCD_DATA_ZEICHEN
			;	// 12. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	CALL  GLCD_DATA_ZEICHEN
			;	
			;
			;	// 3. Zeile und 1.Spalte des Zeichen	
			;	GLCD_SETCURSOR_ZEILE(tmp_zeile + 2);
	MOVLW .2
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+1,W
	CALL  GLCD_SETCURSOR_ZEILE
			;	GLCD_SETCURSOR_SPALTE(tmp_spalte);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcAA+2,W
	CALL  GLCD_SETCURSOR_SPALTE
			;	
			;
			;	// 1. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp1[zeichen]);
	MOVLW .80
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 2. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp2[zeichen]);
	MOVLW .90
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 3. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp3[zeichen]);
	MOVLW .100
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 4. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp4[zeichen]);
	MOVLW .110
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 5. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp5[zeichen]);
	MOVLW .120
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 6. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp6[zeichen]);
	MOVLW .130
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 7. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp7[zeichen]);
	MOVLW .140
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 8. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp8[zeichen]);
	MOVLW .150
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 9. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp9[zeichen]);
	MOVLW .160
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 10. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz10x22_z3sp10[zeichen]);
	MOVLW .170
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcAA+0,W
	CALL  _const2
	CALL  GLCD_DATA_ZEICHEN
			;	// 11. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	CALL  GLCD_DATA_ZEICHEN
			;  	// 12. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	CALL  GLCD_DATA_ZEICHEN
			; 
			; 
			;	// 1. Zeile und Spalte vom Ende des Zeichen	
			;	GLCD_SETCURSOR_ZEILE(tmp_zeile);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcAA+1,W
	GOTO  GLCD_SETCURSOR_ZEILE
			; }

	END


; *** KEY INFO ***

; 0x0106 P0  216 word(s) 10 % : GLCD_ZEICHEN_10x22
; 0x0001 P0  137 word(s)  6 % : _const1
; 0x008A P0  124 word(s)  6 % : _const2

; RAM usage: 30 bytes (4 local), 338 bytes free
; Maximum call level: 1
;  Codepage 0 has  478 word(s) :  23 %
;  Codepage 1 has    0 word(s) :   0 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has    0 word(s) :   0 %
; Total of 478 code words (5 %)
