/****************************************************************************************/
/* Unterprogramme zur Ansteuerung des Grafik-LCD (mit SED1520-Controller) in C (CC5X)	*/
/* (Font 5x7)																			*/
/*																						*/
/* Entwickler: Buchgeher Stefan															*/
/* Entwicklungsbeginn der Software: 5. Maerz 2006										*/
/* Funktionsfaehig seit: 2. April 2006 					 							    */
/* Letzte Bearbeitung: 10. April 2006													*/
/****************************************************************************************/

/****************** Projekt-Header einbinden ********************************************/
#include "PROJEKT.H"
 

/****************** Unterprogramme zur Grafik-LCD-Ansteuerung ***************************/

/****************************************************************************************/
/* GLCD_ZEICHEN_5x7  									     							*/
/*                                                                                      */
/* Aufgabe:                                                                             */
/*	 Ein Zeichen (Character im Format 5x7) am Grafik-LC-Display ausgeben			    */
/*                                                                                      */
/* Uebergabeparameter:                                                                  */
/*   zeichen (im ASCII-Format)			                                                */
/*																						*/
/* Rueckgabeparameter:                                                                  */
/*   keiner																				*/
/*                                                                                      */
/* Vorgehensweise:                                                                      */
/*	 Nacheinander die Spalten eines Zeichens an das Grafik-LC-Display mit dem Unter-	*/
/*   programm GLCD_DATA_ZEICHEN uebergeben. Die Daten fuer die Spalten sind in 		    */
/*	 Tabellen abgelegt, wobei fuer jede Spalte des Zeichens eine eigene Tabelle vor-	*/
/*	 handen ist. Diese Tabellen muessen an anderer Stelle hinzugefuegt werden! Die 		*/
/*	 letzte Spalte muss eine 0 enthalten, also eine "Leerspalte".						*/
/****************************************************************************************/
void GLCD_ZEICHEN_5x7(unsigned char zeichen)
{
	// 1. Spalte des Zeichens
	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp1[zeichen]);

	// 2. Spalte des Zeichens
	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp2[zeichen]);

	// 3. Spalte des Zeichens
	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp3[zeichen]);

	// 4. Spalte des Zeichens
	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp4[zeichen]);

	// 5. Spalte des Zeichens
	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp5[zeichen]);

	// 6. Spalte des Zeichens
	GLCD_DATA_ZEICHEN(0);
}


/****************************************************************************************/
/* GLCD_STRING_5x7:																		*/
/*																						*/
/* Aufgabe: 																			*/
/*	 Dieses Unterprogramm sendet einen String Zeichen fuer Zeichen an das Grafik-LC-	*/
/*	 Display.																			*/
/* 																						*/
/* Uebergabeparameter:                                                                  */
/*	 *pString			                                                                */
/*																						*/
/* Rueckgabeparameter:                                                                  */
/* 	 keiner																				*/
/*                                                                                      */
/* Vorgehensweise:																		*/
/*   + Der Zeiger (engl. Pointer) *pString zeigt auf das erste Zeichen der uebergebenen */
/*     Zeichenkette. Den Inhalt diesee Zeigers in die Variable zeichen kopieren.		*/
/*   + Mit einer Schleife den Inhalt von zeichen an das Grafik-LC-Display uebergeben 	*/
/*	   und die restliche Zeichenkette mit Hilfe des Zeigers Zeichen fuer Zeichen ein-	*/
/*	   lesen und am Grafik-LC-Display ausgeben.											*/
/*																						*/
/* Anmerkung:																			*/
/*   Eine Zeichenkette (engl. String) wird in C mit einem so genannten Nullbyte abge-   */
/*	 schlossen.																			*/
/****************************************************************************************/
//void GLCD_STRING_5x7(const char *pString)
//{
// 	char zeichen;


// 	zeichen = *pString;
//	while(zeichen > 0)
//	{
//		GLCD_ZEICHEN_5x7(zeichen);		// zeichen am Grafk-LC-Display ausgeben
//		pString++;						// Zeiger um 1 erhoehen, er zeigt nun auf das
										// naechstes Zeichen der auszugebenden Zeichen-
										// kette
//		zeichen = *pString;				// Den Inhalt diese Zeigers in die Variable 
//	}									//  zeichen kopieren.	
//} 

 
