
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   1. May 2006  18:51  *************

	processor  16F877
	radix  DEC

	EXTERN GLCD_DATA_ZEICHEN
	EXTERN GLCD_SETCURSOR_ZEILE
	EXTERN GLCD_SETCURSOR_SPALTE
PCL         EQU   0x02
PCLATH      EQU   0x0A
Carry       EQU   0
RP0         EQU   5
RP1         EQU   6
  EXTERN hlp_zeilen_zaehler
  EXTERN hlp_spalten_zaehler

BANK0    UDATA
_LcZA       RES   4
  GLOBAL _LcZA
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
RD          EQU   0
EEPGD       EQU   7

  ; FILE GLCD_FONT8X14.c
			;/****************************************************************************************/
			;/* Unterprogramme zur Ansteuerung des Grafik-LCD (mit SED1520-Controller) in C (CC5X)	*/
			;/* (Font 8x14)																			*/
			;/*																						*/
			;/* Entwickler: Buchgeher Stefan															*/
			;/* Entwicklungsbeginn der Software: 8. April 2006										*/
			;/* Funktionsfaehig seit: 8. April 2006 					 							    */
			;/* Letzte Bearbeitung: 10. April 2006													*/
			;/****************************************************************************************/
			;
			;/****************** Projekt-Header einbinden ********************************************/
			;#include "PROJEKT.H"
			; 
			;
			;/****************** Unterprogramme zur Grafik-LCD-Ansteuerung ***************************/
			;
			;/****************************************************************************************/
			;/* GLCD_ZEICHEN_8x14  									     							*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Ein Zeichen (Charakter im Format 8x14) am Grafik-LC-Display ausgeben		    	*/
			;/*                                                                                      */
			;/* Uebergabeparameter:                                                                  */
			;/* 	 zeichen			                                                                */
			;/*                                                                                      */
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/*                                                                                      */
			;/* Vorgehensweise:                                                                      */
			;/*   + die externen Hilfsregister (hlp_zeilen_zaehler und hlp_spalten_zaehler) sichern, */
			;/*     da sie hier benoetigt, aber gleichzeitig hier auch veraendert werden)			*/
			;/*	 + Nacheinander die Spalten fuer die erste Zeile des auszugebenden Zeichens an das  */
			;/*     Grafik-LC-Display mit dem Unterprogramm GLCD_DATA_ZEICHEN uebergeben. Die Daten  */
			;/*	   fuer die Spalten sind in Tabellen abgelegt, wobei fuer jede Spalte des Zeichens  */
			;/*	   eine eigene Tabelle vorhanden ist. Diese Tabellen muessen an anderer Stelle 		*/
			;/*	   hinzugefuegt werden! Die letzte Spalte muss eine 0 enthalten, also eine "Leer-	*/
			;/*	   spalte".																			*/
			;/*	 + Den Cursor an die naechste Zeile (tmp_zeile + 1) und die erste Spalte des 		*/
			;/*     Zeichens (tmp_spalte) setzen.													*/
			;/*   + In gleicher weise wie vorher die Spalten fuer die zweite Zeile des auszugebenden */
			;/*	   Zeichens an das Grafik-LC-Display mit dem Unterprogramm GLCD_DATA_ZEICHEN 		*/
			;/*	   uebergeben.																		*/
			;/*   + Den Cursor an die erste Zeile des Zeichens (tmp_zeile) und an die Spalte vom 	*/
			;/*	   Ende des Zeichen	(tmp_spalte + 12) setzen										*/
			;/****************************************************************************************/
			;void GLCD_ZEICHEN_8x14(unsigned char zeichen)
			;{

PROG1   CODE
_const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcZA+3
	MOVLW .80
	SUBWF _LcZA+3,W
	BTFSS 0x03,Carry
	GOTO  m001
	RETLW .0
m001	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVLW HIGH(Cgto1)
	MOVWF PCLATH
	MOVF  _LcZA+3,W
	ADDLW LOW(Cgto1)
	BTFSC 0x03,Carry
	INCF  PCLATH,1
	MOVWF PCL
Cgto1
	RETLW .248
	RETLW .0
	RETLW .24
	RETLW .8
	RETLW .0
	RETLW .254
	RETLW .248
	RETLW .14
	RETLW .56
	RETLW .248
	RETLW .252
	RETLW .48
	RETLW .28
	RETLW .12
	RETLW .192
	RETLW .254
	RETLW .252
	RETLW .14
	RETLW .124
	RETLW .252
	RETLW .14
	RETLW .56
	RETLW .14
	RETLW .14
	RETLW .240
	RETLW .230
	RETLW .206
	RETLW .14
	RETLW .238
	RETLW .142
	RETLW .6
	RETLW .28
	RETLW .6
	RETLW .6
	RETLW .60
	RETLW .102
	RETLW .198
	RETLW .6
	RETLW .198
	RETLW .6
	RETLW .6
	RETLW .254
	RETLW .6
	RETLW .134
	RETLW .14
	RETLW .102
	RETLW .198
	RETLW .198
	RETLW .198
	RETLW .6
	RETLW .14
	RETLW .254
	RETLW .142
	RETLW .206
	RETLW .254
	RETLW .230
	RETLW .206
	RETLW .254
	RETLW .238
	RETLW .142
	RETLW .252
	RETLW .0
	RETLW .252
	RETLW .252
	RETLW .254
	RETLW .198
	RETLW .140
	RETLW .254
	RETLW .124
	RETLW .252
	RETLW .248
	RETLW .0
	RETLW .248
	RETLW .120
	RETLW .0
	RETLW .134
	RETLW .8
	RETLW .62
	RETLW .56
	RETLW .248
_const9
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcZA+3
	MOVLW HIGH(cwdata1)
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   _LcZA+3,W
	ANDLW .127
	ADDLW LOW(cwdata1)
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSS 0x03,Carry
	GOTO  m002
	INCF  EEADRH,1
m002	BSF   0x03,RP0
	BSF   0x03,RP1
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC _LcZA+3,0
	GOTO  m003
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW .127
	RETURN
m003	BCF   0x03,RP0
	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	RETURN
cwdata1
	DW    0x1F
	DW    0x870
	DW    0x80F
	DW    0x1F
	DW    0x81E
	DW    0x303F
	DW    0x1878
	DW    0x180F
	DW    0x3F
	DW    0x18BF
	DW    0x3070
	DW    0x387C
	DW    0x380D
	DW    0x3E71
	DW    0x39F3
	DW    0x3060
	DW    0x306E
	DW    0x300C
	DW    0x3FE0
	DW    0x31E1
	DW    0x3FE0
	DW    0x30E7
	DW    0x300C
	DW    0x3FE0
	DW    0x31E1
	DW    0x3FF0
	DW    0x39E3
	DW    0x387F
	DW    0x1F1
	DW    0x39F3
	DW    0x303F
	DW    0x1FE1
	DW    0x1FFF
	DW    0x3F
	DW    0x1FBF
	DW    0x1F
	DW    0xF60
	DW    0xF8C
	DW    0x1F
	DW    0xF9E
GLCD_ZEICHEN_8x14
	GLOBAL GLCD_ZEICHEN_8x14
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcZA+0
			;	char tmp_zeile = hlp_zeilen_zaehler;
	MOVF  hlp_zeilen_zaehler,W
	MOVWF _LcZA+1
			;	char tmp_spalte = hlp_spalten_zaehler;
	MOVF  hlp_spalten_zaehler,W
	MOVWF _LcZA+2
			;  
			;	
			;	// 1.Zeile
			;	// 1. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z1sp1[zeichen]);
	MOVF  _LcZA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 2. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z1sp2[zeichen]);
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 3. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z1sp3[zeichen]);
	MOVLW .20
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 4. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z1sp4[zeichen]);
	MOVLW .30
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 5. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z1sp5[zeichen]);
	MOVLW .40
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 6. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z1sp6[zeichen]);
	MOVLW .50
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 7. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z1sp7[zeichen]);
	MOVLW .60
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 8. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z1sp8[zeichen]);
	MOVLW .70
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;	// 9. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	CALL  GLCD_DATA_ZEICHEN
			;
			;
			;	// 2. Zeile und 1.Spalte des Zeichen
			;	GLCD_SETCURSOR_ZEILE(tmp_zeile + 1);
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  _LcZA+1,W
	CALL  GLCD_SETCURSOR_ZEILE
			;	GLCD_SETCURSOR_SPALTE(tmp_spalte);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcZA+2,W
	CALL  GLCD_SETCURSOR_SPALTE
			;
			;	// 1. Spalte des Zeichens
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z2sp1[zeichen]);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcZA+0,W
	CALL  _const9
	CALL  GLCD_DATA_ZEICHEN
			;	// 2. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z2sp2[zeichen]);
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const9
	CALL  GLCD_DATA_ZEICHEN
			;	// 3. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z2sp3[zeichen]);
	MOVLW .20
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const9
	CALL  GLCD_DATA_ZEICHEN
			;	// 4. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z2sp4[zeichen]);
	MOVLW .30
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const9
	CALL  GLCD_DATA_ZEICHEN
			;	// 5. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z2sp5[zeichen]);
	MOVLW .40
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const9
	CALL  GLCD_DATA_ZEICHEN
			;	// 6. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z2sp6[zeichen]);
	MOVLW .50
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const9
	CALL  GLCD_DATA_ZEICHEN
			;	// 7. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z2sp7[zeichen]);
	MOVLW .60
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const9
	CALL  GLCD_DATA_ZEICHEN
			;	// 8. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(TabZeichensatz8x14_z2sp8[zeichen]);
	MOVLW .70
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcZA+0,W
	CALL  _const9
	CALL  GLCD_DATA_ZEICHEN
			;	// 9. Spalte des Zeichens 
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	CALL  GLCD_DATA_ZEICHEN
			;
			; 
			;	// 1. Zeile und Spalte vom Ende des Zeichen	
			;	GLCD_SETCURSOR_ZEILE(tmp_zeile);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcZA+1,W
	GOTO  GLCD_SETCURSOR_ZEILE
			; }

	END


; *** KEY INFO ***

; 0x00AC P0  115 word(s)  5 % : GLCD_ZEICHEN_8x14
; 0x0001 P0   97 word(s)  4 % : _const1
; 0x0062 P0   74 word(s)  3 % : _const9

; RAM usage: 30 bytes (4 local), 338 bytes free
; Maximum call level: 1
;  Codepage 0 has  287 word(s) :  14 %
;  Codepage 1 has    0 word(s) :   0 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has    0 word(s) :   0 %
; Total of 287 code words (3 %)
