
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   1. May 2006  18:51  *************

	processor  16F877
	radix  DEC

	EXTERN AUSGABEHEX
	EXTERN ADC
	EXTERN GLCD_SETCURSOR_ZEILE
	EXTERN GLCD_SETCURSOR_SPALTE
	EXTERN GLCD_ZEICHEN_5x7
PA0         EQU   3
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6

BANK0    UDATA
tmp_uebergabe_uns16 RES   2
  GLOBAL tmp_uebergabe_uns16
tmp_uebergabe_int16 RES   2
  GLOBAL tmp_uebergabe_int16
  EXTERN ausgabe_zaehler
sollwert    RES   2
  GLOBAL sollwert
istwert     RES   2
  GLOBAL istwert
e_alt       RES   2
  GLOBAL e_alt
e_neu       RES   2
  GLOBAL e_neu
y_alt       RES   2
  GLOBAL y_alt
y_neu       RES   2
  GLOBAL y_neu
Kp          RES   2
  GLOBAL Kp
Ki          RES   2
  GLOBAL Ki
Kd          RES   2
  GLOBAL Kd
PID_STATUS  RES   1
  GLOBAL PID_STATUS
_LcPA       RES   5
  GLOBAL _LcPA

  ; FILE PID.c
			;/****************************************************************************************/
			;/* Unterprogramme zur PID-Regelung in C (CC5X)											*/
			;/*																						*/
			;/* Entwickler: Buchgeher Stefan															*/
			;/* Entwicklungsbeginn der Software: 20. April 2006										*/
			;/* Funktionsfaehig seit:  					 							    */
			;/* Letzte Bearbeitung: 1. Mai 2006													*/
			;/****************************************************************************************/
			;
			;/****************** Projekt-Header einbinden ********************************************/
			;#include "PROJEKT.H"
			;
			;
			;/****************** externe Register ****************************************************/
			;uns16 tmp_uebergabe_uns16;
			;int16 tmp_uebergabe_int16;
			;
			;uns16 sollwert;
			;uns16 istwert;
			;
			;int16 e_alt;				// vorhergehende Regelabweichung
			;int16 e_neu;				// neue Regelabweichung
			;int16 y_alt;				// vorhergehende Stellgroesse
			;int16 y_neu;				// neue Stellgroesse
			;
			;uns16 Kp;
			;uns16 Ki;
			;uns16 Kd;
			;
			;unsigned char PID_STATUS;	// Statusregister fuer PID-Regler
			;//bit pid_ein @ PID_STATUS.0;			// Globale aktivierung der PID-Regelung
			;//bit pid_p_aktiv @ PID_STATUS.5;		// Bit gesetzt: P-Anteil wird im PID-Algorithmus 
			;									//   beruecksichtigt
			;//bit pid_i_aktiv @ PID_STATUS.6;		// Bit gesetzt: I-Anteil wird im PID-Algorithmus 
			;									//   beruecksichtigt
			;//bit pid_d_aktiv @ PID_STATUS.7;		// Bit gesetzt: D-Anteil wird im PID-Algorithmus 
			;									//   beruecksichtigt
			;
			;
			;
			;/****************** Unterprogramm zur Ist- und Sollwerteingabe **************************/
			;
			;/****************************************************************************************/
			;/* ADC:																					*/
			;/*																						*/
			;/* Aufgabe:																				*/
			;/*	 Analog-Digital-Wandlung mit dem PIC-interne ADC fuer den ausgewaehlten ADC-Kanal   */
			;/*	 starten, auf das Wandlungsergebnis warten und dieses dem aufrufenden Programm 		*/
			;/*	 zurueckgeben.																		*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 kanal: 			                                                          		*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 ergebnis:  16-Bit-Ergebnis der Analog-Digital-Wandlung								*/
			;/*                                                                                      */
			;/* Vorgehensweise: 																		*/
			;/*	 + ADC-Kanal auswaehlen (Bits <3:5> im Register ADCON0). Dazu muss die Kanal-Nummer */
			;/*     an diese Position geschoben werden und mit dem Register ADCON0 verknuepft werden */	
			;/*	 + ca. 50 Mikrosekunden (us) warten. Diese Zeit benoetigt der PIC um den internen 	*/
			;/*	   Kondensator mit der zu messenden Analogspannung zu laden.						*/
			;/*	 + Analog-Digital-Wandlung starten. Dazu das Flag GO (im Register ADCON0) setzen.   */
			;/*	 + Warten, bis der PIC mit der Wandlung fertig ist. Der PIC setzt das Flag GO auto- */
			;/*     matisch zurueck, wenn er mit der Analog-Digital-Wandlung fertig ist.				*/
			;/*   + Aus den Registern ADRESL und ADRESH das Ergebnis zusammensetzen und an das auf-  */
			;/*     rufende Unterprogramm (oder Hauptprogramm) zurueckgeben							*/
			;/*                                                                                      */
			;/* Anmerkung: 																			*/
			;/*	 Das Ausgabeformat der ADC-Wandlung, also wie die 10 Ergebnisbits in den Registern  */
			;/*   ADRESL und ADRESH abgelegt werden wird an anderer Stelle (z.B. im Unterprogramm    */
			;/*   INIT) konfiguriert.																*/
			;/****************************************************************************************/
			;void SOLL_ISTWERT_EINLESEN(void)
			;{

PROG2   CODE
SOLL_ISTWERT_EINLESEN
	GLOBAL SOLL_ISTWERT_EINLESEN
			;	// Istwert von ADC-Eingang AN0 (Kanal 0) einlesen und in der externen Variable 
			;	//   istwert sichern
			;	ADC(0);
	MOVLW .0
	BCF   0x0A,PA0
	CALL  ADC
	BSF   0x0A,PA0
			;	istwert = tmp_uebergabe_uns16;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmp_uebergabe_uns16,W
	MOVWF istwert
	MOVF  tmp_uebergabe_uns16+1,W
	MOVWF istwert+1
			;
			;	// Sollwert von ADC-Eingang AN2 (Kanal 2) einlesen und in der externen Variable 
			;	//   sollwert sichern
			;	ADC(1);
	MOVLW .1
	BCF   0x0A,PA0
	CALL  ADC
	BSF   0x0A,PA0
			;	sollwert = tmp_uebergabe_uns16;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmp_uebergabe_uns16,W
	MOVWF sollwert
	MOVF  tmp_uebergabe_uns16+1,W
	MOVWF sollwert+1
			;}
	RETURN
			;
			;
			;/****************** Unterprogramm zum Reglerparameter einlesen **************************/
			;
			;/****************************************************************************************/
			;/* PID_INIT:																			*/
			;/*																						*/
			;/* Aufgabe:																				*/
			;/*	 e_alt (Regelabweichung) und y_alt (Stellgroesse) mit 0 initialisieren				*/
			;/****************************************************************************************/
			;
			;void PID_INIT(void)
			;{
PID_INIT
	GLOBAL PID_INIT
			;	e_alt = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  e_alt
	CLRF  e_alt+1
			;	y_alt = 0;
	CLRF  y_alt
	CLRF  y_alt+1
			;}
	RETURN
			; 
			;
			;
			;/****************************************************************************************/
			;/* ADC:																					*/
			;/*																						*/
			;/* Aufgabe:																				*/
			;/*	 Analog-Digital-Wandlung mit dem PIC-interne ADC fuer den ausgewaehlten ADC-Kanal   */
			;/*	 starten, auf das Wandlungsergebnis warten und dieses dem aufrufenden Programm 		*/
			;/*	 zurueckgeben.																		*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 kanal: 			                                                          		*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 ergebnis:  16-Bit-Ergebnis der Analog-Digital-Wandlung								*/
			;/*                                                                                      */
			;/* Vorgehensweise: 																		*/
			;/*	 + ADC-Kanal auswaehlen (Bits <3:5> im Register ADCON0). Dazu muss die Kanal-Nummer */
			;/*     an diese Position geschoben werden und mit dem Register ADCON0 verknuepft werden */	
			;/*	 + ca. 50 Mikrosekunden (us) warten. Diese Zeit benoetigt der PIC um den internen 	*/
			;/*	   Kondensator mit der zu messenden Analogspannung zu laden.						*/
			;/*	 + Analog-Digital-Wandlung starten. Dazu das Flag GO (im Register ADCON0) setzen.   */
			;/*	 + Warten, bis der PIC mit der Wandlung fertig ist. Der PIC setzt das Flag GO auto- */
			;/*     matisch zurueck, wenn er mit der Analog-Digital-Wandlung fertig ist.				*/
			;/*   + Aus den Registern ADRESL und ADRESH das Ergebnis zusammensetzen und an das auf-  */
			;/*     rufende Unterprogramm (oder Hauptprogramm) zurueckgeben							*/
			;/*                                                                                      */
			;/* Anmerkung: 																			*/
			;/*	 Das Ausgabeformat der ADC-Wandlung, also wie die 10 Ergebnisbits in den Registern  */
			;/*   ADRESL und ADRESH abgelegt werden wird an anderer Stelle (z.B. im Unterprogramm    */
			;/*   INIT) konfiguriert.																*/
			;/****************************************************************************************/
			;void REGLERPARAMETER_EINLESEN(void)
			;{
REGLERPARAMETER_EINLESEN
	GLOBAL REGLERPARAMETER_EINLESEN
			;	// Kp von ADC-Eingang AN3 (Kanal 3) einlesen und in der externen Variable 
			;	//   Kp sichern
			;	ADC(2);
	MOVLW .2
	BCF   0x0A,PA0
	CALL  ADC
	BSF   0x0A,PA0
			;	Kp = tmp_uebergabe_uns16;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmp_uebergabe_uns16,W
	MOVWF Kp
	MOVF  tmp_uebergabe_uns16+1,W
	MOVWF Kp+1
			;
			;	// Ki von ADC-Eingang AN4 (Kanal 4) einlesen und in der externen Variable
			;	//   Ki sichern
			;	ADC(3);
	MOVLW .3
	BCF   0x0A,PA0
	CALL  ADC
	BSF   0x0A,PA0
			;	Ki = tmp_uebergabe_uns16;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmp_uebergabe_uns16,W
	MOVWF Ki
	MOVF  tmp_uebergabe_uns16+1,W
	MOVWF Ki+1
			;
			;	// Kd von ADC-Eingang AN5 (Kanal 5) einlesen und in der externen Variable
			;	//   Kd sichern
			;	ADC(4);
	MOVLW .4
	BCF   0x0A,PA0
	CALL  ADC
	BSF   0x0A,PA0
			;	Kd = tmp_uebergabe_uns16;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmp_uebergabe_uns16,W
	MOVWF Kd
	MOVF  tmp_uebergabe_uns16+1,W
	MOVWF Kd+1
			;}
	RETURN
			;
			;
			;
			;void PID_ROUTINE(void)
			;{
PID_ROUTINE
	GLOBAL PID_ROUTINE
			;//	int16 abweichung;
			;//	int16 ausgabe;
			;	int16 temp;
			;
			;
			; 
			;
			;
			;	// Regelabweichung (Error) breechnen
			;	e_neu = (int16)(sollwert - istwert);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  istwert+1,W
	SUBWF sollwert+1,W
	MOVWF e_neu+1
	MOVF  istwert,W
	SUBWF sollwert,W
	MOVWF e_neu
	BTFSS 0x03,Carry
	DECF  e_neu+1,1
			;
			;
			;	if (pid_ein) 		
	BTFSS PID_STATUS+0,0
	GOTO  m011
			;	{
			;		// PID-Regelung einschalten
			;		if (pid_p_aktiv)
	BTFSS PID_STATUS+0,5
	GOTO  m003
			;		{
			;			// Proportionalanteil
			;			y_neu = e_neu * Kp;
	MOVF  e_neu,W
	MOVWF _LcPA+3
	MOVF  e_neu+1,W
	MOVWF _LcPA+4
	MOVLW .16
	MOVWF _LcPA+2
m001	BCF   0x03,Carry
	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   y_neu,1
	RLF   y_neu+1,1
	RLF   _LcPA+3,1
	RLF   _LcPA+4,1
	BTFSS 0x03,Carry
	GOTO  m002
	MOVF  Kp+1,W
	ADDWF y_neu+1,1
	MOVF  Kp,W
	ADDWF y_neu,1
	BTFSC 0x03,Carry
	INCF  y_neu+1,1
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	DECFSZ _LcPA+2,1
	GOTO  m001
			;		}
			;		else
	GOTO  m004
			;		{
			;			y_neu = 0;
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  y_neu
	CLRF  y_neu+1
			;		}
			;
			;
			;		if (pid_i_aktiv)
m004	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PID_STATUS+0,6
	GOTO  m007
			;		{
			;			// I-Anteil
			;			temp = e_alt + e_neu;
	MOVF  e_neu+1,W
	ADDWF e_alt+1,W
	MOVWF _LcPA+1
	MOVF  e_neu,W
	ADDWF e_alt,W
	MOVWF _LcPA+0
	BTFSC 0x03,Carry
	INCF  _LcPA+1,1
			;	//		temp = temp * (uns16)100;
			;	//		temp = temp / Tn;
			;	//		temp = temp / (uns16)2;
			;			temp = temp * Ki;
	MOVF  _LcPA+0,W
	MOVWF _LcPA+3
	MOVF  _LcPA+1,W
	MOVWF _LcPA+4
	MOVLW .16
	MOVWF _LcPA+2
m005	BCF   0x03,Carry
	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   _LcPA+0,1
	RLF   _LcPA+1,1
	RLF   _LcPA+3,1
	RLF   _LcPA+4,1
	BTFSS 0x03,Carry
	GOTO  m006
	MOVF  Ki+1,W
	ADDWF _LcPA+1,1
	MOVF  Ki,W
	ADDWF _LcPA+0,1
	BTFSC 0x03,Carry
	INCF  _LcPA+1,1
m006	BCF   0x03,RP0
	BCF   0x03,RP1
	DECFSZ _LcPA+2,1
	GOTO  m005
			;			
			;			y_neu = y_neu + y_alt;
	MOVF  y_alt+1,W
	ADDWF y_neu+1,1
	MOVF  y_alt,W
	ADDWF y_neu,1
	BTFSC 0x03,Carry
	INCF  y_neu+1,1
			;			y_neu = y_neu + temp;
	MOVF  _LcPA+1,W
	ADDWF y_neu+1,1
	MOVF  _LcPA+0,W
	ADDWF y_neu,1
	BTFSC 0x03,Carry
	INCF  y_neu+1,1
			;		}
			;		 
			;
			;		if (pid_d_aktiv)
m007	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PID_STATUS+0,7
	GOTO  m010
			;		{
			;			// D-Anteil
			;			temp = e_neu - e_alt;
	MOVF  e_alt+1,W
	SUBWF e_neu+1,W
	MOVWF _LcPA+1
	MOVF  e_alt,W
	SUBWF e_neu,W
	MOVWF _LcPA+0
	BTFSS 0x03,Carry
	DECF  _LcPA+1,1
			;	//		temp = temp * Kp;
			;	//		temp = temp / (uns16)100;		// Abtastzeit
			;	//		temp = temp * Tv;
			;			temp = temp * Kd;
	MOVF  _LcPA+0,W
	MOVWF _LcPA+3
	MOVF  _LcPA+1,W
	MOVWF _LcPA+4
	MOVLW .16
	MOVWF _LcPA+2
m008	BCF   0x03,Carry
	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   _LcPA+0,1
	RLF   _LcPA+1,1
	RLF   _LcPA+3,1
	RLF   _LcPA+4,1
	BTFSS 0x03,Carry
	GOTO  m009
	MOVF  Kd+1,W
	ADDWF _LcPA+1,1
	MOVF  Kd,W
	ADDWF _LcPA+0,1
	BTFSC 0x03,Carry
	INCF  _LcPA+1,1
m009	BCF   0x03,RP0
	BCF   0x03,RP1
	DECFSZ _LcPA+2,1
	GOTO  m008
			;
			;			y_neu = y_neu + temp;
	MOVF  _LcPA+1,W
	ADDWF y_neu+1,1
	MOVF  _LcPA+0,W
	ADDWF y_neu,1
	BTFSC 0x03,Carry
	INCF  y_neu+1,1
			;		}
			;	 
			;	}
			;	else
m010	GOTO  m012
			;	{
			;		// PID-Regelung ausschalten
			;		
			;		y_neu = 0;
m011	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  y_neu
	CLRF  y_neu+1
			;	}
			;
			;
			;	e_alt = e_neu;
m012	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  e_neu,W
	MOVWF e_alt
	MOVF  e_neu+1,W
	MOVWF e_alt+1
			;	y_alt = y_neu;
	MOVF  y_neu,W
	MOVWF y_alt
	MOVF  y_neu+1,W
	MOVWF y_alt+1
			;
			;	tmp_uebergabe_int16 = y_neu;
	MOVF  y_neu,W
	MOVWF tmp_uebergabe_int16
	MOVF  y_neu+1,W
	MOVWF tmp_uebergabe_int16+1
			;}
	RETURN
			;
			;
			;void AUSGABE_PID_PARAMETER(void)
			;{
AUSGABE_PID_PARAMETER
	GLOBAL AUSGABE_PID_PARAMETER
			;	ausgabe_zaehler++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  ausgabe_zaehler,1
			;
			;	switch (ausgabe_zaehler)
	MOVF  ausgabe_zaehler,W
	XORLW .1
	BTFSC 0x03,Zero_
	GOTO  m013
	XORLW .3
	BTFSC 0x03,Zero_
	GOTO  m014
	XORLW .1
	BTFSC 0x03,Zero_
	GOTO  m015
	XORLW .7
	BTFSC 0x03,Zero_
	GOTO  m016
	XORLW .1
	BTFSC 0x03,Zero_
	GOTO  m019
	XORLW .3
	BTFSC 0x03,Zero_
	GOTO  m022
	XORLW .1
	BTFSC 0x03,Zero_
	GOTO  m025
	XORLW .15
	BTFSC 0x03,Zero_
	GOTO  m028
	GOTO  m029
			;	{
			;		case 1: 	
			;			// Sollwert am Display ausgeben
			;			GLCD_SETCURSOR_ZEILE(0);
m013	MOVLW .0
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_ZEILE
	BSF   0x0A,PA0
			;			GLCD_SETCURSOR_SPALTE(0);
	MOVLW .0
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_SPALTE
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('S');
	MOVLW .83
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('o');
	MOVLW .111
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(':');
	MOVLW .58
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 			AUSGABEHEX(sollwert.high8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  sollwert+1,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('.');
	MOVLW .46
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			AUSGABEHEX(sollwert.low8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  sollwert,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('h');
	MOVLW .104
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			break;
	GOTO  m029
			;
			;		case 2: 
			;			// Istwert am Display ausgeben
			;			GLCD_SETCURSOR_ZEILE(1);
m014	MOVLW .1
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_ZEILE
	BSF   0x0A,PA0
			;			GLCD_SETCURSOR_SPALTE(0);
	MOVLW .0
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_SPALTE
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('I');
	MOVLW .73
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('s');
	MOVLW .115
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(':');
	MOVLW .58
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 			AUSGABEHEX(istwert.high8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  istwert+1,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('.');
	MOVLW .46
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			AUSGABEHEX(istwert.low8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  istwert,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('h');
	MOVLW .104
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			break;
	GOTO  m029
			;
			;		case 3: 
			;			// Regelabweichung (Error) am Display ausgeben
			;			GLCD_SETCURSOR_ZEILE(2);
m015	MOVLW .2
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_ZEILE
	BSF   0x0A,PA0
			;			GLCD_SETCURSOR_SPALTE(0);
	MOVLW .0
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_SPALTE
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('e');
	MOVLW .101
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(':');
	MOVLW .58
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(' ');
	MOVLW .32
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			AUSGABEHEX(e_neu.high8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  e_neu+1,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('.');
	MOVLW .46
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 			AUSGABEHEX(e_neu.low8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  e_neu,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('h');
	MOVLW .104
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			break;
	GOTO  m029
			;
			;		case 4: 
			;			// PID-Regelung ein oder aus
			;			GLCD_SETCURSOR_ZEILE(3);
m016	MOVLW .3
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_ZEILE
	BSF   0x0A,PA0
			;			GLCD_SETCURSOR_SPALTE(0);
	MOVLW .0
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_SPALTE
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('P');
	MOVLW .80
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('I');
	MOVLW .73
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('D');
	MOVLW .68
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(' ');
	MOVLW .32
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			if (pid_ein) 		
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PID_STATUS+0,0
	GOTO  m017
			;			{
			;				GLCD_ZEICHEN_5x7('E');
	MOVLW .69
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('i');
	MOVLW .105
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('n');
	MOVLW .110
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			}
			;			else
	GOTO  m018
			;			{
			;				GLCD_ZEICHEN_5x7('A');
m017	MOVLW .65
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('u');
	MOVLW .117
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('s');
	MOVLW .115
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			}
			;			break;
m018	GOTO  m029
			;
			;		case 5: 
			;			// Kp am Display ausgeben
			;			GLCD_SETCURSOR_ZEILE(0);
m019	MOVLW .0
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_ZEILE
	BSF   0x0A,PA0
			;			GLCD_SETCURSOR_SPALTE(60);
	MOVLW .60
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_SPALTE
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('K');
	MOVLW .75
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('p');
	MOVLW .112
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(':');
	MOVLW .58
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			if (pid_p_aktiv)
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PID_STATUS+0,5
	GOTO  m020
			;			{
			; 				AUSGABEHEX(Kp.high8);
	MOVF  Kp+1,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('.');
	MOVLW .46
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 				AUSGABEHEX(Kp.low8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  Kp,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('h');
	MOVLW .104
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			}
			;			else
	GOTO  m021
			;			{
			;				GLCD_ZEICHEN_5x7('a');
m020	MOVLW .97
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('u');
	MOVLW .117
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('s');
	MOVLW .115
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 			}
			;			break;
m021	GOTO  m029
			;
			;		case 6: 
			;			// Ki am Display ausgeben
			;			GLCD_SETCURSOR_ZEILE(1);
m022	MOVLW .1
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_ZEILE
	BSF   0x0A,PA0
			;			GLCD_SETCURSOR_SPALTE(60);
	MOVLW .60
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_SPALTE
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('K');
	MOVLW .75
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('i');
	MOVLW .105
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(':');
	MOVLW .58
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			if (pid_i_aktiv)
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PID_STATUS+0,6
	GOTO  m023
			;			{
			; 				AUSGABEHEX(Ki.high8);
	MOVF  Ki+1,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('.');
	MOVLW .46
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 				AUSGABEHEX(Ki.low8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  Ki,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('h');
	MOVLW .104
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			}
			;			else
	GOTO  m024
			;			{
			;				GLCD_ZEICHEN_5x7('a');
m023	MOVLW .97
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('u');
	MOVLW .117
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('s');
	MOVLW .115
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 			}
			;			break;
m024	GOTO  m029
			;
			;		case 7: 
			;			// Kd am Display ausgeben
			;			GLCD_SETCURSOR_ZEILE(2);
m025	MOVLW .2
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_ZEILE
	BSF   0x0A,PA0
			;			GLCD_SETCURSOR_SPALTE(60);
	MOVLW .60
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_SPALTE
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('K');
	MOVLW .75
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('d');
	MOVLW .100
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(':');
	MOVLW .58
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			if (pid_d_aktiv)
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PID_STATUS+0,7
	GOTO  m026
			;			{
			; 				AUSGABEHEX(Kd.high8);
	MOVF  Kd+1,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('.');
	MOVLW .46
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 				AUSGABEHEX(Kd.low8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  Kd,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('h');
	MOVLW .104
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			}
			;			else
	GOTO  m027
			;			{
			;				GLCD_ZEICHEN_5x7('a');
m026	MOVLW .97
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('u');
	MOVLW .117
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;				GLCD_ZEICHEN_5x7('s');
	MOVLW .115
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 			}
			;			break;
m027	GOTO  m029
			;
			;		case 8: 
			;			// Ausgangswert am Display ausgeben
			;			GLCD_SETCURSOR_ZEILE(3);
m028	MOVLW .3
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_ZEILE
	BSF   0x0A,PA0
			;			GLCD_SETCURSOR_SPALTE(60);
	MOVLW .60
	BCF   0x0A,PA0
	CALL  GLCD_SETCURSOR_SPALTE
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('a');
	MOVLW .97
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('u');
	MOVLW .117
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7(':');
	MOVLW .58
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 			AUSGABEHEX(y_neu.high8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  y_neu+1,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('.');
	MOVLW .46
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			; 			AUSGABEHEX(y_neu.low8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  y_neu,W
	BCF   0x0A,PA0
	CALL  AUSGABEHEX
	BSF   0x0A,PA0
			;			GLCD_ZEICHEN_5x7('h');
	MOVLW .104
	BCF   0x0A,PA0
	CALL  GLCD_ZEICHEN_5x7
	BSF   0x0A,PA0
			;
			;			ausgabe_zaehler = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  ausgabe_zaehler
			;			break;
	GOTO  m029
			;	}
			;
			;}
m029	RETURN

	END


; *** KEY INFO ***

; 0x0800 P1   21 word(s)  1 % : SOLL_ISTWERT_EINLESEN
; 0x081C P1   31 word(s)  1 % : REGLERPARAMETER_EINLESEN
; 0x0815 P1    7 word(s)  0 % : PID_INIT
; 0x083B P1  156 word(s)  7 % : PID_ROUTINE
; 0x08D7 P1  419 word(s) 20 % : AUSGABE_PID_PARAMETER

; RAM usage: 31 bytes (5 local), 337 bytes free
; Maximum call level: 0
;  Codepage 0 has    1 word(s) :   0 %
;  Codepage 1 has  634 word(s) :  30 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has    0 word(s) :   0 %
; Total of 635 code words (7 %)
