
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   1. May 2006  18:51  *************

	processor  16F877
	radix  DEC

	__config 0x3D3A

	EXTERN GLCD_INIT
	EXTERN GLCD_CLEAR
	EXTERN GLCD_ZEICHEN_5x7
	EXTERN SOLL_ISTWERT_EINLESEN
	EXTERN REGLERPARAMETER_EINLESEN
	EXTERN PID_INIT
	EXTERN PID_ROUTINE
	EXTERN AUSGABE_PID_PARAMETER
STATUS      EQU   0x03
PCLATH      EQU   0x0A
PA0         EQU   3
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
T0IF        EQU   2

SHRAM    UDATA_SHR
_LcQA       RES   1
  GLOBAL _LcQA
TMR0        EQU   0x01
PORTC       EQU   0x07
T2CON       EQU   0x12
CCPR1L      EQU   0x15
CCP1CON     EQU   0x17
CCPR2L      EQU   0x1B
CCP2CON     EQU   0x1D
ADRESH      EQU   0x1E
ADCON0      EQU   0x1F
ADON        EQU   0
GO          EQU   2
ADCS0       EQU   6
ADCS1       EQU   7
  EXTERN tmp_uebergabe_uns16
  EXTERN tmp_uebergabe_int16

BANK0    UDATA
ausgabe_zaehler RES   1
  GLOBAL ausgabe_zaehler
  EXTERN PID_STATUS
FLAGISRHP   RES   1
  GLOBAL FLAGISRHP
ZAEHLERISR8MSEK RES   1
  GLOBAL ZAEHLERISR8MSEK
_LcQB       RES   20
  GLOBAL _LcQB
TRISA       EQU   0x85
TRISB       EQU   0x86
OPTION_REG  EQU   0x81
TRISC       EQU   0x87
TRISD       EQU   0x88
TRISE       EQU   0x89
PR2         EQU   0x92
ADRESL      EQU   0x9E
ADCON1      EQU   0x9F

STARTUP CODE 0x0
	GOTO main

  ; FILE pid_demo.c
			;/****************************************************************************************/
			;/* Demonstrationsbeispiel eines digitalen PID-Regler am Beispiel eines inversen Pendels */
			;/* in C (CC5X)																			*/
			;/*																						*/
			;/* Entwickler: Buchgeher Stefan															*/
			;/* Entwicklungsbeginn der Software: 16. Maerz 2006										*/
			;/* Funktionsfaehig seit:  								 							    */
			;/* Letzte Bearbeitung: 27. April 2006													*/
			;/****************************************************************************************/
			;
			; 
			;/****************** Include-Dateien *****************************************************/
			;//#include "16f877.h"
			;#include "PROJEKT.H"
			;#include <int16CXX.H>	 			// Ist fuer die Interrupts notwendig
			;#include <INLINE.H> 				// Ist fuer Assembleranweisungen notwendig
			;
			;
			;/****************** Pragma-Anweisungen **************************************************/
			;//#pragma chip PIC16F877				// PICmicro Device
			;//#pragma library 1					//.. library functions that are deleted if unused
			;
			;
			;/****************** Strukturen  *********************************************************/
			;/* keine Strukturen verwendet */
			;
			;
			;/****************** Externe Register  ***************************************************/
			;char FLAGISRHP;   					// beinhaltet Botschaftsflags ISR -> HP
			;char ZAEHLERISR8MSEK;				// Zaehlregister fuer 10ms-Zeitbasis
			;
			;//uns16 tmp_uebergabe_uns16;
			;char ausgabe_zaehler;
			;
			;
			;/****************** Bits in den externen Registern **************************************/
			;/* Register FLAGSISRHP */
			;bit	FLAG8MSEK					@ FLAGISRHP.0;
			; 
			;
			;/****************** Portbelegung ********************************************************/
			;/* Port B */
			;/*#pragma char GLCD_CTRL			@ PORTB       
			;#pragma char GLCD_CTRL_TRIS 	@ TRISB 
			;
			;bit GLCD_WR						@ GLCD_CTRL.1;
			;bit	GLCD_RD						@ GLCD_CTRL.2;
			;bit GLCD_CS1					@ GLCD_CTRL.3;
			;bit GLCD_CS2					@ GLCD_CTRL.4;
			;bit GLCD_A0						@ GLCD_CTRL.5;*/
			;
			;/* Port D */
			;/*#pragma char GLCD_DATA 			@ PORTD       
			;#pragma char GLCD_DATA_TRIS 	@ TRISD */
			;
			;
			;/****************** Konstanten **********************************************************/
			;/* Konstanten fuer Zeitbasen */
			;//#define 	KONSTISR8MSEK 		9  // fuer 8 ms
			;#define 	KONSTISR8MSEK 		112  // fuer 100 ms
			;
			;
			;
			;/****************** Konfigurations-Bits *************************************************/ 
			;#pragma config |= 0b.11110100111010
			;/*         		     ++------++------- Bit 13-12, 5-4 (CP1:CP0): FLASH Memory Code Protection
			;					   ||||||  ||||        0  0  : 0000h to 1FFFh code protected
			;					   ||||||  ||||        0  1  : 1000h to 1FFFh code protected
			;					   ||||||  ||||        1  0  : 1F00h to 1FFFh code protected
			;					   ||||||  ||||    ->  1  1  : Code protection off
			;					   +-------------- Bit 11 (DEBUG): In-Circuit Debugger Mode
			;						|||||  ||||         0 : DEBUG on  (= enabled)
			;						|||||  ||||    ->   1 : DEBUG off (= disabled)
			;						+------------- Bit 10 : Reserve
			;						 +------------ Bit  9 (WRT): FLASH Programm Memory Write Enable
			;						  |||  ||||    ->   0 : WRT off   (= diasbled)
			;						  |||  ||||         1 : WRT on    (= enabled)
			;						  +----------- Bit  8 (CPD): Data EE Memory Code Protection
			;						   ||  ||||         0 : CPD on    (= enabled)
			;						   ||  ||||    ->   1 : CPD off   (= disabled)
			;						   +---------- Bit  7 (LVP): Low Voltage ICSP Enable Bit
			;							|  ||||    ->   0 : LVP off   (= disabled)
			;							|  ||||         1 : LVP on    (= enabled)
			;							+--------- Bit  6 (BODEN): Brown-Out Detection
			;							   ||||    ->   0 : BODEN on  (= disabled)
			;							   ||||         1 : BODEN off (= enabled)
			;							   +------ Bit  3 (PWRTE): Power Up Timer
			;								|||         0 : PWRT on   (= enabled)
			;								|||    ->   1 : PWRT off  (= disabled) 
			;								+----- Bit  2 (WDTE): Watchdog Timer
			;								 ||    ->   0 : WDT off   (= disabled)
			;								 ||         1 : WDT on    (= enabled))
			;								 ++--- Bit 1-0 (FOSC2:FOSC0): Oszillator Selection
			;									      0 0 : LP Oszillator
			;										  0 1 : XT Oszillator
			;							 	       -> 1 0 : HS Oszillator
			; 										  1 1 : RC Oszillator
			;*/
			;
			;
			;/****************** Funktionsprototypen *************************************************/
			;/* Initialisierung des Mikrocontroller */
			;//void INIT(void);
			;
			;/* Unterprogramme zur Datenausgabe */
			;//void AUSGABE(void);
			;//void AUSGABEBCD(unsigned char wert);
			;//void AUSGABEBCD_10x22(unsigned char wert); 
			;
			;
			;
			;/* Unterprogramm zur Analog-Digital-Wandlung */
			;//uns16 ADC(char kanal);
			;
			;/* Unterprogramm zur Ist- und Sollwerteingabe */
			;//void Soll_Istwerte_einlesen(void);
			;
			;
			;/* Unterprogramm zur Motoransteuerung mittels IC TLE5205-2 und PWM */
			;//void PWM_TLE5205(uns16 wert);
			;
			;
			;/* Sonstige Unterprogramme */
			;//void delay_us(char mikro);
			;
			;
			;
			;
			;/****************** ISR - Timer0 ********************************************************/
			;
			;/****************************************************************************************/
			;/* Interrupt Service Routine:								     						*/
			;/* 											     										*/
			;/* Aufruf:										     									*/
			;/*  	alle 8 ms									     								*/
			;/* 											     										*/
			;/* Aufgaben:										     								*/
			;/* 		+ w-Register (=Arbeitsregister) und Status-Register zwischenspeichern 			*/
			;/*		  (int_save_registers)															*/
			;/*		+ Zeitbasis fuer 8 Millisekunde erzeugen						   				*/
			;/* 		+ Das Timer-Interrupt-Flag T0IF wieder loeschen					     			*/
			;/*		+ w-Register (=Arbeitsregister) und Statusregister wiederherstellen 	     	*/
			;/*		  (int_restore_registers)														*/
			;/****************************************************************************************/
			;#pragma origin 4						 
			;
			;interrupt InterruptRutine(void)			// Interruptroutine
			;{

ISERVER CODE 0x4
InterruptRutine
			;	int_save_registers					// W, STATUS (und  PCLATH) retten
	MOVWF _LcQA+0
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+0
	MOVF  PCLATH,W
	MOVWF _LcQB+1
	CLRF  PCLATH
			; 
			;	// Beginn der eigentlichen ISR-Routine
			;	ZAEHLERISR8MSEK--;
	DECF  ZAEHLERISR8MSEK,1
			;	if (ZAEHLERISR8MSEK == 0)
	MOVF  ZAEHLERISR8MSEK,1
	BTFSS 0x03,Zero_
	GOTO  m001
			;	{	
			;		FLAG8MSEK = 1;					// Botschaftsflag setzen
	BSF   FLAGISRHP+0,0
			;		ZAEHLERISR8MSEK = KONSTISR8MSEK;  // Zaehlregister fuer den 8-ms-Takt mit
	MOVLW .112
	MOVWF ZAEHLERISR8MSEK
			;	}									// der Konstante KONSTISR8MSEK neu laden
			;							
			;	T0IF = 0; 							// Timer-Interrupt-Flag T0IF wieder loeschen	
m001	BCF   0x0B,T0IF
			;	// Ende der eigentlichen ISR-Routine
			;
			;	int_restore_registers				// W, STATUS (und PCLATH) Wiederherstellen
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcQB+1,W
	MOVWF PCLATH
	SWAPF _LcQB+0,W
	MOVWF STATUS
	SWAPF _LcQA+0,1
	SWAPF _LcQA+0,W
			;}
	RETFIE

  ; FILE C:\Programme\bknd\CC5X\MATH16.H
			;// SIZE
			;
			;#pragma library 1
			;/*
			;uns16 operator* _mult8x8( uns8 arg1, uns8 arg2);
			;int16 operator* _multS8x8( int8 arg1, int8 arg2);
			;uns16 operator* _multU16x8( uns16 arg1, uns8 arg2);
			;uns16 operator* _mult16x16( uns16 arg1, uns16 arg2);
			;uns16 operator/ _divU16_8( uns16 arg1, uns8 arg2);
			;uns16 operator/ _divU16_16( uns16 arg1, uns16 arg2);
			;int16 operator/ _divS16_8( int16 arg1, int8 arg2);
			;int16 operator/ _divS16_16( int16 arg1, int16 arg2);
			;uns8 operator% _remU16_8( uns16 arg1, uns8 arg2);
			;uns16 operator% _remU16_16( uns16 arg1, uns16 arg2);
			;int8 operator% _remS16_8( int16 arg1, int8 arg2);
			;int16 operator% _remS16_16( int16 arg1, int16 arg2);
			;*/
			;
			;#if __CoreSet__ < 1600
			; #define genAdd(r,a) W=a; btsc(Carry); W=incsz(a); r+=W;
			; #define genSub(r,a) W=a; btss(Carry); W=incsz(a); r-=W;
			; #define genAddW(r,a) W=a; btsc(Carry); W=incsz(a); W=r+W;
			; #define genSubW(r,a) W=a; btss(Carry); W=incsz(a); W=r-W;
			;#else
			; #define genAdd(r,a) W=a; r=addWFC(r);
			; #define genSub(r,a) W=a; r=subWFB(r);
			; #define genAddW(r,a) W=a; W=addWFC(r);
			; #define genSubW(r,a) W=a; W=subWFB(r);
			;#endif
			;
			;
			;int8 operator*( int8 arg1, int8 arg2)  @
			;
			;uns16 operator* _mult8x8( uns8 arg1, uns8 arg2)
			;{

PROG1   CODE
_mult8x8
			;    uns16 rval;
			;    char counter = sizeof(arg2)*8;
			;    rval.high8 = 0;
			;    W = arg1;
			;    do  {
			;        arg2 = rr( arg2);
			;        if (Carry)
			;            rval.high8 += W;
			;        rval = rr( rval);
			;        counter = decsz(counter);
			;    } while (1);
			;    return rval;
			;}
			;
			;
			;int16 operator* _multS8x8( int8 arg1, int8 arg2)
			;{
_multS8x8
			;    uns16 rval;
			;    char counter = sizeof(arg2)*8;
			;    int8 tmpArg2 = arg2;
			;    rval.high8 = 0;
			;    W = arg1;
			;    do  {
			;        tmpArg2 = rr( tmpArg2);
			;        if (Carry)
			;            rval.high8 += W;
			;        rval = rr( rval);
			;        counter = decsz(counter);
			;    } while (1);
			;    W = arg2;
			;    if (arg1 < 0)
			;        rval.high8 -= W;
			;    W = arg1;
			;    if (arg2 < 0)
			;        rval.high8 -= W;
			;    return rval;
			;}
			;
			;
			;uns16 operator*( uns8 arg1, uns16 arg2) exchangeArgs @
			;
			;uns16 operator* _multU16x8( uns16 arg1, uns8 arg2)
			;{
_multU16x8
			;    uns16 rval;
			;    uns8 rvalH = 0;
			;    char counter = sizeof(arg1)*8;
			;    W = arg2;
			;    do  {
			;        arg1 = rr( arg1);
			;        if (Carry)
			;            rvalH += W;
			;        rvalH = rr(rvalH);
			;        rval = rr(rval);
			;        counter = decsz(counter);
			;    } while (1);
			;    return rval;
			;}
			;
			;
			;int16 operator*( int16 arg1, int16 arg2) @
			;
			;uns16 operator* _mult16x16( uns16 arg1, uns16 arg2)
			;{
_mult16x16
			;    uns16 rval;
			;    char counter = sizeof(arg1)*8;
			;    do  {
			;        Carry = 0;
			;        rval = rl( rval);
			;        arg1 = rl( arg1);
			;        if (Carry)
			;            rval += arg2;
			;        counter = decsz(counter);
			;    } while (1);
			;    return rval;
			;}
			;
			;
			;
			;uns16 operator/ _divU16_8( uns16 arg1, uns8 arg2)
			;{
_divU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+10
			;    uns8 rm = 0;
	CLRF  _LcQB+11
			;    char counter = sizeof(arg1)*8+1;
	MOVLW .17
	MOVWF _LcQB+12
			;    goto ENTRY;
	GOTO  m004
			;    do  {
			;        rm = rl( rm);
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   _LcQB+11,1
			;        uns8 tmp = rl( tmp);
	RLF   _LcQB+13,1
			;        W = rm - arg2;
	MOVF  _LcQB+10,W
	SUBWF _LcQB+11,W
			;        if (tmp&1)
	BTFSS _LcQB+13,0
	GOTO  m003
			;            Carry = 1;
	BSF   0x03,Carry
			;        if (Carry)
m003	BTFSS 0x03,Carry
	GOTO  m004
			;            rm = W;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+11
			;       ENTRY:
			;        arg1 = rl( arg1);
m004	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   _LcQB+8,1
	RLF   _LcQB+9,1
			;        counter = decsz(counter);
	DECFSZ _LcQB+12,1
			;    } while (1);
	GOTO  m002
			;    return arg1;
	MOVF  _LcQB+8,W
	RETURN
			;}
			;
			;
			;uns16 operator/ _divU16_16( uns16 arg1, uns16 arg2)
			;{
_divU16_16
			;    uns16 rm = 0;
			;    char counter = sizeof(arg1)*8+1;
			;    goto ENTRY;
			;    do  {
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto ENTRY;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;        Carry = 1;
			;       ENTRY:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    return arg1;
			;}
			;
			;
			;int8  operator/ (int8 arg1, int8 arg2) @
			;
			;int16 operator/ _divS16_8( int16 arg1, int8 arg2)
			;{
_divS16_8
			;    uns8 rm = 0;
			;    char counter = 16+1;
			;    char sign = arg1.high8 ^ arg2.high8;
			;    if (arg1 < 0)  {
			;       INVERT:
			;        arg1 = -arg1;
			;        if (!counter)
			;            return arg1;
			;    }
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    goto ENTRY;
			;    do  {
			;        rm = rl( rm);
			;        W = rm - arg2;
			;        if (Carry)
			;            rm = W;
			;       ENTRY:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        goto INVERT;
			;    return arg1;
			;}
			;
			;
			;int16 operator/ _divS16_16( int16 arg1, int16 arg2)
			;{
_divS16_16
			;    uns16 rm = 0;
			;    char counter = sizeof(arg1)*8+1;
			;    char sign = arg1.high8 ^ arg2.high8;
			;    if (arg1 < 0)  {
			;       INVERT:
			;        arg1 = -arg1;
			;        if (!counter)
			;            return arg1;
			;    }
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    goto ENTRY;
			;    do  {
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto ENTRY;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;        Carry = 1;
			;       ENTRY:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        goto INVERT;
			;    return arg1;
			;}
			;
			;
			;uns8 operator% _remU16_8( uns16 arg1, uns8 arg2)
			;{
_remU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+10
			;    uns8 rm = 0;
	CLRF  _LcQB+11
			;    char counter = sizeof(arg1)*8;
	MOVLW .16
	MOVWF _LcQB+12
			;    do  {
			;        arg1 = rl( arg1);
m005	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   _LcQB+8,1
	RLF   _LcQB+9,1
			;        rm = rl( rm);
	RLF   _LcQB+11,1
			;        uns8 tmp = rl( tmp);
	RLF   _LcQB+13,1
			;        W = rm - arg2;
	MOVF  _LcQB+10,W
	SUBWF _LcQB+11,W
			;        if (tmp&1)
	BTFSS _LcQB+13,0
	GOTO  m006
			;            Carry = 1;
	BSF   0x03,Carry
			;        if (Carry)
m006	BTFSS 0x03,Carry
	GOTO  m007
			;            rm = W;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+11
			;        counter = decsz(counter);
m007	BCF   0x03,RP0
	BCF   0x03,RP1
	DECFSZ _LcQB+12,1
			;    } while (1);
	GOTO  m005
			;    return rm;
	MOVF  _LcQB+11,W
	RETURN
			;}
			;
			;
			;uns16 operator% _remU16_16( uns16 arg1, uns16 arg2)
			;{
_remU16_16
			;    uns16 rm = 0;
			;    char counter = sizeof(arg1)*8;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto NOSUB;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;      NOSUB:
			;        counter = decsz(counter);
			;    } while (1);
			;    return rm;
			;}
			;
			;
			;int8 operator% (int8 arg1, int8 arg2) @
			;
			;int8 operator% _remS16_8( int16 arg1, int8 arg2)
			;{
_remS16_8
			;    int8 rm = 0;
			;    char counter = 16;
			;    char sign = arg1.high8;
			;    if (arg1 < 0)
			;        arg1 = -arg1;
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        W = rm - arg2;
			;        if (Carry)
			;            rm = W;
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        rm = -rm;
			;    return rm;
			;}
			;
			;
			;int16 operator% _remS16_16( int16 arg1, int16 arg2)
			;{
_remS16_16
			;    int16 rm = 0;
			;    char counter = sizeof(arg1)*8;
			;    char sign = arg1.high8;
			;    if (arg1 < 0)
			;        arg1 = -arg1;
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto NOSUB;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;      NOSUB:
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        rm = -rm;
			;    return rm;

  ; FILE pid_demo.c
			;
			; 
			;
			;
			;/****************** Unterprogramme und Funktionen ***************************************/
			;
			;/****************** externe Unterprogramme einbinden ************************************/
			;/* Mathematik-Routinen */
			;#include <MATH16.H>
			;
			; 
			;
			;/****************************************************************************************/
			;/* INIT:																				*/
			;/*																						*/
			;/* Aufgabe:																				*/
			;/*	 Initialisierung des Prozessor:														*/
			;/*		+ Timer 0 (TMR0) loeschen														*/
			;/*		+ Timer 0-ISR soll alle 8ms aufgerufen werden, daher den Vorteiler mit 16 laden */
			;/*		  (bei einem 18,432MHz-Quarz													*/
			;/*   	+ Port A als Eingang (fuer ADC), Port B und Port D als Ausgang definieren,		*/
			;/*      + ADC konfigurieren																*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 zeichen			                                                                */
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/* 	 keiner																				*/
			;/****************************************************************************************/
			;void INIT(void)
			;{
INIT
	GLOBAL INIT
			;	// Timer-0-Interrupt
			;	TMR0 = 0;							// Timer 0 auf 0 voreinstellen
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  TMR0
			;	OPTION = 0b.1000.0011;				// Pull-Up-Widerstaende am Port B deaktivieren
	MOVLW .131
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;										// Timer-ISR alle 8ms aufrufen (Vorteiler = 16)
			;
			;	// Ports
			;	TRISA = 0xFF;						// Port A  und Port E muessen bei verwendung als 
	MOVLW .255
	MOVWF TRISA
			;	TRISE = 0xFF;						//   ADC als Eingang konfiguriert werden
	MOVLW .255
	MOVWF TRISE
			; 	TRISB = 0;							// Port B als Ausgang definieren
	CLRF  TRISB
			;	TRISC = 0b.1111.1001;				// Port C: Bits 1 und 2 als Ausgang definieren
	MOVLW .249
	MOVWF TRISC
			;										// Port C: Bits 0 und 3 bis 7 als Eingang definieren	
			;	TRISD = 0;							// Port D als Ausgang definieren
	CLRF  TRISD
			;
			;	// ADC
			;	ADON = 1;							// ADC global einschalten
	BCF   0x03,RP0
	BSF   0x1F,ADON
			;	ADCON1 = 0b.1000.0010;				// Ganzer Port A als Analog; Vref+ = Vdd, Vref- = Vss 
	MOVLW .130
	BSF   0x03,RP0
	MOVWF ADCON1
			;										//   und linksbuendig
			;	ADCS0 = 0;							// Geschwindigkeit des ADC mit ADCS0 und ADCS1
	BCF   0x03,RP0
	BCF   0x1F,ADCS0
			;	ADCS1 = 1;
	BSF   0x1F,ADCS1
			;									 
			;	ZAEHLERISR8MSEK = KONSTISR8MSEK;	// Zaehlregister fuer 8-ms-Zeitbasis
	MOVLW .112
	MOVWF ZAEHLERISR8MSEK
			;										// initialisieren
			;
			;	// PWM-Module
			;	T2CON = 0b.0000.0100;				// Vorteiler Timer 2: 1:1, Timer 2 einschalten
	MOVLW .4
	MOVWF T2CON
			;	PR2 = 0b.1111.1111;					// 
	MOVLW .255
	BSF   0x03,RP0
	MOVWF PR2
			;	CCP1CON = 0b.0000.1100;				// PWM 1, Ausgang RC2
	MOVLW .12
	BCF   0x03,RP0
	MOVWF CCP1CON
			;	CCP2CON = 0b.0000.1100;				// PWM 2, Ausgang RC1
	MOVLW .12
	MOVWF CCP2CON
			;	CCPR1L = 255;						// IC TLE5205 bremst (CCP1 (RC2) <-> IN1
	MOVLW .255
	MOVWF CCPR1L
			;	CCPR2L = 0;							// IC TLE5205 bremst (CCP2 (RC1) <-> IN2
	CLRF  CCPR2L
			;
			;
			;	ausgabe_zaehler = 0;
	CLRF  ausgabe_zaehler
			;}
	RETURN
			;									 
			;
			; 
			;
			;/****************************************************************************************/
			;/* AUSGABEHEX:																			*/
			;/*																						*/
			;/* Aufgabe:																				*/
			;/*	 Zeichen und Texte (Strings) an beliebiger Position am Grafik-LC-Display ausgeben.	*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 keine			                                                          		    */
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/*                                                                                      */
			;/* Vorgehensweise: 																		*/
			;/*	 + Grafik-LC-Display loeschen (Unterprogramm GLCD_CLEAR)							*/
			;/*	 + Cursor an eine beliebige Stelle positionieren (Unterprogramm GLCD_SETCURSOR)		*/
			;/*	 + Einzelne Zeichen (mit dem Unterprogramm GLCD_ZEICHEN) oder ganze Texte (mit dem  */
			;/*	   Unterprogramm GLCD_STRING) am Grafik-LC-Display ausgeben.						*/
			;/****************************************************************************************/
			;void AUSGABEHEX(unsigned char wert)
			;{
AUSGABEHEX
	GLOBAL AUSGABEHEX
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+2
			;	unsigned char help;
			;	unsigned char help_modulo;
			;
			;	// Erste Stelle
			;
			;	help = wert;
	MOVF  _LcQB+2,W
	MOVWF _LcQB+3
			;	SWAPF(help,1);
	SWAPF _LcQB+3,1
			;	help = help & 0x0F;
	MOVLW .15
	ANDWF _LcQB+3,1
			;	GLCD_ZEICHEN_5x7(help);	
	MOVF  _LcQB+3,W
	CALL  GLCD_ZEICHEN_5x7
			;
			;		
			;	// Zweite Stelle
			;	wert = wert & 0x0F;
	MOVLW .15
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF _LcQB+2,1
			;	GLCD_ZEICHEN_5x7(wert);	
	MOVF  _LcQB+2,W
	GOTO  GLCD_ZEICHEN_5x7
			;}
			;
			;
			;/****************************************************************************************/
			;/* AUSGABEBCD:																			*/
			;/*																						*/
			;/* Aufgabe:																				*/
			;/*	 Zeichen und Texte (Strings) an beliebiger Position am Grafik-LC-Display ausgeben.	*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 keine			                                                          		    */
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 keiner																				*/
			;/*                                                                                      */
			;/* Vorgehensweise: 																		*/
			;/*	 + Grafik-LC-Display loeschen (Unterprogramm GLCD_CLEAR)							*/
			;/*	 + Cursor an eine beliebige Stelle positionieren (Unterprogramm GLCD_SETCURSOR)		*/
			;/*	 + Einzelne Zeichen (mit dem Unterprogramm GLCD_ZEICHEN) oder ganze Texte (mit dem  */
			;/*	   Unterprogramm GLCD_STRING) am Grafik-LC-Display ausgeben.						*/
			;/****************************************************************************************/
			;void AUSGABEBCD(unsigned char wert)
			;{
AUSGABEBCD
	GLOBAL AUSGABEBCD
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+5
			;	unsigned char help;
			;	unsigned char help_modulo;
			;
			;	// Hunderterstelle
			;	help = (char)(wert / 100);
	MOVF  _LcQB+5,W
	MOVWF _LcQB+8
	CLRF  _LcQB+9
	MOVLW .100
	CALL  _divU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcQB+8,W
	MOVWF _LcQB+6
			;	GLCD_ZEICHEN_5x7(help);	
	MOVF  _LcQB+6,W
	CALL  GLCD_ZEICHEN_5x7
			;   	help_modulo = wert % 100;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcQB+5,W
	MOVWF _LcQB+8
	CLRF  _LcQB+9
	MOVLW .100
	CALL  _remU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+7
			;
			;	// Zehnerstelle
			;	help = (char)(help_modulo / 10);
	MOVF  _LcQB+7,W
	MOVWF _LcQB+8
	CLRF  _LcQB+9
	MOVLW .10
	CALL  _divU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcQB+8,W
	MOVWF _LcQB+6
			;	GLCD_ZEICHEN_5x7(help);	
	MOVF  _LcQB+6,W
	CALL  GLCD_ZEICHEN_5x7
			;   	help_modulo = help_modulo % 10;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcQB+7,W
	MOVWF _LcQB+8
	CLRF  _LcQB+9
	MOVLW .10
	CALL  _remU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+7
			;
			;	// Einerstelle
			;	GLCD_ZEICHEN_5x7(help_modulo);	
	MOVF  _LcQB+7,W
	GOTO  GLCD_ZEICHEN_5x7
			;}
			;
			;
			;//void AUSGABEBCD_10x22(unsigned char wert)
			;//{
			;//	unsigned char help;
			;//	unsigned char help_modulo;
			;
			;	// Hunderterstelle
			;//	help = (char)(wert / 100);
			;//	GLCD_ZEICHEN_10x22(help);	
			;//   help_modulo = wert % 100;
			;
			;	// Zehnerstelle
			;//	help = (char)(help_modulo / 10);
			;//	GLCD_ZEICHEN_10x22(help);	
			;//  help_modulo = help_modulo % 10;
			;
			;	// Einerstelle
			;//	GLCD_ZEICHEN_10x22(help_modulo);	
			;//}
			;
			;
			;
			;void delay_us(char mikro)
			;{
delay_us
	GLOBAL delay_us
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+14
			;	#asm
			;	wdh9	nop
m008	NOP  
			;	nop
	NOP  
			;	decfsz	mikro,f
	DECFSZ _LcQB+14,1
			;	goto	wdh9
	GOTO  m008
			;	#endasm
			;}
	RETURN
			;
			;
			;
			;/****************** Unterprogramm zur Analog-Digital-Wandlung ***************************/
			;
			;/****************************************************************************************/
			;/* ADC:																					*/
			;/*																						*/
			;/* Aufgabe:																				*/
			;/*	 Analog-Digital-Wandlung mit dem PIC-interne ADC fuer den ausgewaehlten ADC-Kanal   */
			;/*	 starten, auf das Wandlungsergebnis warten und dieses dem aufrufenden Programm 		*/
			;/*	 zurueckgeben.																		*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 kanal: 			                                                          		*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 6-Bit-Ergebnis der Analog-Digital-Wandlung	im EXTERNEN UEBERGABEREGISTER			*/
			;/*   (tmp_uebergabe_uns16)																*/
			;/*                                                                                      */
			;/* Vorgehensweise: 																		*/
			;/*	 + ADC-Kanal auswaehlen (Bits <3:5> im Register ADCON0). Dazu muss die Kanal-Nummer */
			;/*     an diese Position geschoben werden und mit dem Register ADCON0 verknuepft werden */	
			;/*	 + ca. 50 Mikrosekunden (us) warten. Diese Zeit benoetigt der PIC um den internen 	*/
			;/*	   Kondensator mit der zu messenden Analogspannung zu laden.						*/
			;/*	 + Analog-Digital-Wandlung starten. Dazu das Flag GO (im Register ADCON0) setzen.   */
			;/*	 + Warten, bis der PIC mit der Wandlung fertig ist. Der PIC setzt das Flag GO auto- */
			;/*     matisch zurueck, wenn er mit der Analog-Digital-Wandlung fertig ist.				*/
			;/*   + Aus den Registern ADRESL und ADRESH das Ergebnis zusammensetzen und an das auf-  */
			;/*     rufende Unterprogramm (oder Hauptprogramm) zurueckgeben							*/
			;/*                                                                                      */
			;/* Anmerkung: 																			*/
			;/*	 Das Ausgabeformat der ADC-Wandlung, also wie die 10 Ergebnisbits in den Registern  */
			;/*   ADRESL und ADRESH abgelegt werden wird an anderer Stelle (z.B. im Unterprogramm    */
			;/*   INIT) konfiguriert.																*/
			;/****************************************************************************************/
			;void ADC(char kanal)
			;{
ADC
	GLOBAL ADC
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcQB+15
			;//	uns16	ergebnis;
			;	
			;
			;	ADCON0 = ADCON0 & 0b.1100.0111;
	MOVLW .199
	ANDWF ADCON0,1
			;	kanal = kanal << 3;
	BCF   0x03,Carry
	RLF   _LcQB+15,1
	BCF   0x03,Carry
	RLF   _LcQB+15,1
	BCF   0x03,Carry
	RLF   _LcQB+15,1
			;	ADCON0 = ADCON0 | kanal;
	MOVF  _LcQB+15,W
	IORWF ADCON0,1
			;		
			;	delay_us(50);
	MOVLW .50
	CALL  delay_us
			;
			;	GO = 1;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x1F,GO
			;	while(GO);
m009	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x1F,GO
	GOTO  m010
	GOTO  m009
			;
			;	tmp_uebergabe_uns16.low8 = ADRESL;			// externes Uebergaberegister
m010	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ADRESL,W
	BCF   0x03,RP0
	MOVWF tmp_uebergabe_uns16
			;	tmp_uebergabe_uns16.high8 = ADRESH;
	MOVF  ADRESH,W
	MOVWF tmp_uebergabe_uns16+1
			;
			;//	return ergebnis;
			;}
	RETURN
			;
			;
			;/****************** Unterprogramm zur Motoransteuerung mittels IC TLE5205-2 und PWM *****/
			;
			;/****************************************************************************************/
			;/* PWM_TLE5205:																			*/
			;/*																						*/
			;/* Aufgabe:																				*/
			;/*	 Analog-Digital-Wandlung mit dem PIC-interne ADC fuer den ausgewaehlten ADC-Kanal   */
			;/*	 starten, auf das Wandlungsergebnis warten und dieses dem aufrufenden Programm 		*/
			;/*	 zurueckgeben.																		*/
			;/*																						*/
			;/* Uebergabeparameter:                                                                  */
			;/*	 kanal: 			                                                          		*/
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*	 ergebnis:  16-Bit-Ergebnis der Analog-Digital-Wandlung								*/
			;/*                                                                                      */
			;/* Vorgehensweise: 																		*/
			;/*	 + ADC-Kanal auswaehlen (Bits <3:5> im Register ADCON0). Dazu muss die Kanal-Nummer */
			;/*     an diese Position geschoben werden und mit dem Register ADCON0 verknuepft werden */	
			;/*	 + ca. 50 Mikrosekunden (us) warten. Diese Zeit benoetigt der PIC um den internen 	*/
			;/*	   Kondensator mit der zu messenden Analogspannung zu laden.						*/
			;/*	 + Analog-Digital-Wandlung starten. Dazu das Flag GO (im Register ADCON0) setzen.   */
			;/*	 + Warten, bis der PIC mit der Wandlung fertig ist. Der PIC setzt das Flag GO auto- */
			;/*     matisch zurueck, wenn er mit der Analog-Digital-Wandlung fertig ist.				*/
			;/*   + Aus den Registern ADRESL und ADRESH das Ergebnis zusammensetzen und an das auf-  */
			;/*     rufende Unterprogramm (oder Hauptprogramm) zurueckgeben							*/
			;/*                                                                                      */
			;/* Anmerkung: 																			*/
			;/*	 Das Ausgabeformat der ADC-Wandlung, also wie die 10 Ergebnisbits in den Registern  */
			;/*   ADRESL und ADRESH abgelegt werden wird an anderer Stelle (z.B. im Unterprogramm    */
			;/*   INIT) konfiguriert.																*/
			;/****************************************************************************************/
			;void PWM_TLE5205(void)
			;{
PWM_TLE5205
	GLOBAL PWM_TLE5205
			;	int16 wert;									// 16 Bit signed
			;
			;
			;	wert = tmp_uebergabe_int16;					// 16-Bit-Uebergabewert 
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmp_uebergabe_int16,W
	MOVWF _LcQB+16
	MOVF  tmp_uebergabe_int16+1,W
	MOVWF _LcQB+17
			;												//   (tmp_uebergabe_int16) im Register
			;												//   Wert sichern		
			;	if (wert.15 == 0)
	BTFSC _LcQB+17,7
	GOTO  m011
			;	{
			;		// wert ist eine negative Zahl
			;		wert = wert << 1;		
	BCF   0x03,Carry
	RLF   _LcQB+16,1
	RLF   _LcQB+17,1
			;
			;		COMF(wert.high8,1);						// Bits invertiern	
	COMF  _LcQB+17,1
			;			
			;		Carry = 0;								// Carry-Flag loeschen
	BCF   0x03,Carry
			;		wert.high8 = wert.high8 >> 2;			// Ausgleich des Totgangs des Motors
	BCF   0x03,Carry
	RRF   _LcQB+17,1
	BCF   0x03,Carry
	RRF   _LcQB+17,1
			;
			;		CCPR1L = wert.high8;
	MOVF  _LcQB+17,W
	MOVWF CCPR1L
			;		CCPR2L = wert.high8;;	
	MOVF  _LcQB+17,W
	MOVWF CCPR2L
			;	}
			;	else
	GOTO  m012
			;	{
			;		// wert ist eine positive Zahl
			;		wert = wert << 1;
m011	BCF   0x03,Carry
	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   _LcQB+16,1
	RLF   _LcQB+17,1
			;
			;		Carry = 0;								// Carry-Flag loeschen
	BCF   0x03,Carry
			;		wert.high8 = wert.high8 >> 2;			// Ausgleich des Totgangs des Motors
	BCF   0x03,Carry
	RRF   _LcQB+17,1
	BCF   0x03,Carry
	RRF   _LcQB+17,1
			;
			;
			;		CCPR2L = wert.high8;
	MOVF  _LcQB+17,W
	MOVWF CCPR2L
			;		CCPR1L = 255;
	MOVLW .255
	MOVWF CCPR1L
			;	}
			;	
			;}
m012	RETURN
			;
			;
			;
			;
			;
			;
			;
			;/****************** Hauptprogramm *******************************************************/
			;
			;/****************************************************************************************/
			;/* Aufgaben des Hauptprogramms:							     							*/
			;/*	 + Controller initialisieren (Unterprogramm INIT)				     				*/
			;/*   + Grafik-LC-Display initialisieren (Unterprogramm GLCD_INIT)						*/
			;/*   + Grafik-LC-Display loeschen (Unterprogramm GLCD_CLEAR)							*/
			;/*	 + Interrupt freigeben								     							*/
			;/*	 + Taetigkeiten/Unterprogramme, die alle 10 Sekunden durchgefuehrt werden muessen:	*/
			;/*		+ blabl			*/
			;/****************************************************************************************/
			;void main(void)
			;{
main
			;	uns16 temp;
			; 
			;
			;	INIT();								// Controller initialisieren
	CALL  INIT
			;    GLCD_INIT();						// Grafik-LC-Display initialisieren
	CALL  GLCD_INIT
			; 
			;	GLCD_CLEAR();						// Grafik-LC-Display loeschen
	CALL  GLCD_CLEAR
			;
			;	PID_INIT();							// Register fuer PID-Regelung initialisieren
	BSF   0x0A,PA0
	CALL  PID_INIT
	BCF   0x0A,PA0
			;
			;	INTCON = 0b.1010.0000;				// Timer0 freigeben durch Setzen von
	MOVLW .160
	MOVWF INTCON
			;										// GIE und T0IE im Register INTCON
			;	while(1)
			;	{
			;		if (FLAG8MSEK)					// Alle 8 Millisekunden
m013	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS FLAGISRHP+0,0
	GOTO  m014
			;		{
			;			// aktuelle Soll- und Istwerte einlesen
			;			SOLL_ISTWERT_EINLESEN();
	BSF   0x0A,PA0
	CALL  SOLL_ISTWERT_EINLESEN
	BCF   0x0A,PA0
			;
			;			// Reglerparameter einlesen
			;			REGLERPARAMETER_EINLESEN();
	BSF   0x0A,PA0
	CALL  REGLERPARAMETER_EINLESEN
	BCF   0x0A,PA0
			;
			;			// Regelalgorithmus
			;			PID_ROUTINE();
	BSF   0x0A,PA0
	CALL  PID_ROUTINE
	BCF   0x0A,PA0
			;
			;			// Stellgroesse ausgeben
			;			PWM_TLE5205();
	CALL  PWM_TLE5205
			;
			;			// Reglerparameter und Ausgabewert am Display ausgeben
			;			AUSGABE_PID_PARAMETER();
	BSF   0x0A,PA0
	CALL  AUSGABE_PID_PARAMETER
	BCF   0x0A,PA0
			;			
			;			// Jumper einelesen und im Register PID_STATUS sichern
			;			PID_STATUS = PORTC;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PORTC,W
	MOVWF PID_STATUS
			;			
			; 
			;			FLAG8MSEK = 0;				// Botschaftsflag fuer den 10-Milli-
	BCF   FLAGISRHP+0,0
			;		}								// Sekunden-Takt loeschen
			;		
			;	}	
m014	GOTO  m013

	END


; *** KEY INFO ***

; 0x0056 P0   39 word(s)  1 % : INIT
; 0x008D P0   47 word(s)  2 % : AUSGABEBCD
; 0x007D P0   16 word(s)  0 % : AUSGABEHEX
; 0x00C4 P0   31 word(s)  1 % : ADC
; 0x00E3 P0   37 word(s)  1 % : PWM_TLE5205
; 0x00BC P0    8 word(s)  0 % : delay_us
; 0x0004 P0   25 word(s)  1 % : InterruptRutine
; 0x001D P0   29 word(s)  1 % : _divU16_8
; 0x003A P0   28 word(s)  1 % : _remU16_8
; 0x0108 P0   31 word(s)  1 % : main

; RAM usage: 49 bytes (21 local), 319 bytes free
; Maximum call level: 1 (+1 for interrupt)
;  Codepage 0 has  292 word(s) :  14 %
;  Codepage 1 has    0 word(s) :   0 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has    0 word(s) :   0 %
; Total of 292 code words (3 %)
